var AbleToShowHoverDialog = true;
var BoomerangIsAlreadyRunning = false;
var BoomerangIsHavingTroubleAuthenticating = false;
var AuthenticatedGuserAddresses = [];
var UserClearedLocalStorage = false;

var BOOMERANG_CALENDAR_DOWNLOAD_URL = "https://boomerangcalendar.com";
var ADD_EVENT_COUNT_FOR_VIRAL_HOOK = 10;
var ADD_EVENT_VIRAL_HOOK_TEXT = "With Boomerang Calendar, I just added my " + ADD_EVENT_COUNT_FOR_VIRAL_HOOK + "th meeting w/o leaving my inbox. You should try it too. " + BOOMERANG_CALENDAR_DOWNLOAD_URL;
var DELETE_TENTATIVE_EVENT_VIRAL_HOOK_TEXT = "Tentative meetings in Boomerang Calendar just saved me from double booking. Save yourself from a messy calendar " + BOOMERANG_CALENDAR_DOWNLOAD_URL;
var SUGGEST_TIME_COUNT_FOR_VIRAL_HOOK = 15;
var SUGGEST_TIME_VIRAL_HOOK_TEXT = "Since I started using Boomerang Calendar, I have successfully arranged " + SUGGEST_TIME_COUNT_FOR_VIRAL_HOOK + " meetings w/o hassle. " + BOOMERANG_CALENDAR_DOWNLOAD_URL;

var loc = String(document.location);

if (loc.indexOf("mu/mp") === -1 && // don't run in offline gmail
    loc.indexOf("mail-static") === -1 && // don't run in gmail's hidden iframes
    document.body.contentEditable !== "true" && // don't run in edit areas
    $(window).width() > 0 && // don't run in gmail's hidden iframes
    $(window).height() > 0) // ditto
{
    prepare_boomerang_meetings();
} // TODO: consider doing some logging

var retryCount = 0;
function prepare_boomerang_meetings()
{
    var guser = get_gmail_user();
    if (!guser) {
        if(document.readyState !== "complete") {
            $(window).load(prepare_boomerang_meetings);
        } else if(retryCount < 3) {
            retryCount++;
            setTimeout(prepare_boomerang_meetings, 100 + retryCount * 300);
        } else {
            // Only give up if the page has loaded and we still can't find the user's e-mail after a couple of retries
            console.error("Boomerang Calendar couldn't load. No email address was detected.");
        }

        return;
    }

    if (!boomerang_css_exists_in_framedoc()){
        add_css_to_iframe();
    }
    if(!css_exists_in_root_document()) {
        add_css_to_root_document();
    }

    get_authenticated_guser_addresses();

    // analytics has to be instantiated before tutorials
    setup_analytics_for_iframes();

    var isBlocked = read_from_localStorage(LOCAL_STORAGE_BLOCK_THIS_ACCOUNT) === "true";
    var shouldShowTutorial = read_from_localStorage(LOCAL_STORAGE_LAST_UPDATED) == null;

    if (isBlocked){
        quit_boomerang_meetings();
    }
    else if(shouldShowTutorial){
        setTimeout(function(){
            if(AuthenticatedGuserAddresses.indexOf(guser)>-1){
                UserClearedLocalStorage = true;
            }
            display_intro_dialog();
        }, 4000);
    }
    else{
        run_boomerang_meetings();
    }
}

function quit_boomerang_meetings(){
    write_to_localStorage(LOCAL_STORAGE_BLOCK_THIS_ACCOUNT, "true");
    setInterval(function(){
        if (Has_Static_Images){
            add_management_link();
        }
    }, 1000);
}

function run_boomerang_meetings()
{
    if (BoomerangIsAlreadyRunning){
        return;
    }
    BoomerangIsAlreadyRunning = true;

    store_authenticated_guser_address(get_gmail_user());
    write_to_localStorage(LOCAL_STORAGE_BLOCK_THIS_ACCOUNT, "false");

    add_script_to_document(b4c_initialize_google_maps);

    if (get_gmail_language() === "English-US"){
        load_US_date_parser();
    }
    else{
        load_UK_date_parser();
    }

    sync_with_google_calendar_if_necessary();

    setInterval(boomerang_meetings_loop, 500);
    setTimeout(boomerang_meetings_loop, 0); // Run once immediately to reduce flicker inital onload
    setInterval(sync_loop, MINUTES_TO_CHECK_IF_LOCAL_STORAGE_IS_IN_SYNC*60*1000);

}

function setup_analytics_for_iframes() {
    // settings page records analytics by sending postMessage calls do main frame
    window.addEventListener("message", function(e) {
        if(e.origin !== "https://boomerangcalendar.baydin.com") { return; }

        var data = JSON.parse(e.data);
        track_event(data.category, data.action, data.label);
    }, false);

    // Bridge implements track_event via PostMessage to
    // an analytics-specific iFrame
    Bridge.init("https://boomerangcalendar.baydin.com/analytics_iframe",
        "https://boomerangcalendar.baydin.com");
}

function track_event(category, action, label, value, noninteraction) {
    // passing through sendMessage to an on-domain iFrame,
    // which then logs to google analytics
    try {
      Bridge.track_event({
          category: category,
          action: action,
          label: label,
          value: value,
          noninteraction: noninteraction
      });
    } catch (e) {
      // TODO: more cleverly diagnose when tracking event fails
    }

}


function b4c_initialize_google_maps() {
}


function boomerang_meetings_loop()
{
    if (Has_Static_Images){
        add_management_link();
        add_boomerang_calendar_button_to_email_thread();
        if (get_thread_id().indexOf("#") === -1 || b4g_is_preview_pane()){
            highlight_meeting_times();
        }
        loc = document.location.toString();
        var frameDoc = get_frame();
        editWindowClasses = $(EDIT_WINDOW_SELECTOR, frameDoc);
        // See if we're editing a message
        if (editWindowClasses.length > 0 &&
        (loc.indexOf('compose') > 0 || loc.indexOf('drafts') > 0 || is_pop_out_window() || $(SUBJECT_LINE_SELECTOR, frameDoc).length > 0))
        {
            add_insert_meeting_links();
        }
    }
}

function sync_loop()
{
        sync_with_google_calendar_if_necessary();
}

function add_management_link()
{
    var frameDoc = get_frame();
    var management = $("#b4c_manage", frameDoc);
    if(management.length > 0 || !get_gmail_user())
    {
        return;
    }

        var gmailAppSelectorIcon = $("#gbwa");
        if (gmailAppSelectorIcon.length==0){
            gmailAppSelectorIcon = $(".gb_kb");
        }


        gmailAppSelectorIcon.first().before(
                        '<div class="manage_menu" style="display: inline-block; -webkit-flex: 0 0 auto; flex: 0 0 auto;" id="b4c_manage">' +
                            '<div>' + 
                                '<img id="b4c_app_loader_icon" src="https://s3.amazonaws.com/BoomerangCalendar/images/bcaltopbarlight.png" title="Boomerang Calendar" style="position:relative; top:6px; padding-left:4px; padding-right:10px;"/>' +
                            '</div>' + 
                        '</div>'
                    )

         var gmailBarIcons = $(".gb_2");

        gmailBarIcons.click(function() { $(frameDoc).click(); })

        $("#b4c_app_loader_icon").hover(function() {
            $(this).attr("src", "https://s3.amazonaws.com/BoomerangCalendar/images/bcaltopbarcolor.png");
        }, function() {
            $(this).attr("src", "https://s3.amazonaws.com/BoomerangCalendar/images/bcaltopbarlight.png");
        });

        $("#b4c_manage", frameDoc).click(function(){
            open_top_menu_chrome_bar($(this));
        });

        var B4G_LAUNCHER_WIDTH = 40;

        var topToolbar = $(".gb_5.gb_tb.gb_f.gb_sb");
        var currentMinWidth = topToolbar.css("min-width");
        var newMinWidth = (parseInt(currentMinWidth, 10) + B4G_LAUNCHER_WIDTH).toString() + "px";   
        topToolbar.css("min-width", newMinWidth);

}

/**
* Checks if the boomerang-calendar-menu is visible or not. 
* Returns true if menu is open
*/
function menu_is_open(frame) {
    return ( $('#boomerang-calendar-menu', frame).length > 0 );
}


/**
 * gets added to the top row, to the right of Reply / Archive / Spam / etc
 */
function add_boomerang_calendar_button_to_email_thread()
{
    var frameDoc = get_frame();
    var existingButton = $(".boomerang-calendar-button", frameDoc);
    if(existingButton.length > 0)
    {
        return;
    }
    var messageBodyElt = $(MESSAGE_BODY, frameDoc);
    if (messageBodyElt.length < 1)
    {
        return;
    }
    //Build our boomerang button
    var button = document.createElement('div');

    button.innerHTML = "<div aria-haspopup='true' style='-webkit-user-select: none; -moz-user-select:none;margin-bottom:0px;margin-top:-2px; outline: none;' role='button' class='T-I J-J5-Ji ar7 nf T-I-ax7 L3' tabindex='0'><img class='f tk3N6e-I-J3' src='" + get_bcal_logo_url() + "' style='vertical-align: middle;'/> B Cal <div class='VP5otc-d2fWKd tk3N6e-I-J3 J-J5-Ji'> </div></div>";
    $(button).attr("class", "G-Ni J-J5-Ji boomerang-calendar-button b4c_button");

    var buttonCopy = null;
    var menuBar = $(MENU_BAR_SELECTOR, frameDoc);
    for(var i = 0; i < menuBar.length; i++)
    {
        buttonCopy = button.cloneNode(true);
        buttonCopy.addEventListener('click', function(e) {
            toggle_boomerang_calendar_button_menu(e, this);
        }, false);
        menuBar.get(i).appendChild(buttonCopy);
    }
    $(".boomerang-calendar-button").mousedown(function() {
        var $composeContainer = $(this).closest(".aeJ,.ar4").find(".I5,.fN");

        if($composeContainer.length <= 0) { return; } // Reply window isn't open

        // For pre-pop-in compose: ".Am.Al:not(:has(iframe))" for HTML compose, plain text is handled later
        // For new pop-in compose: ".LW-avf" for chrome and ".Am.Al > iframe" for firefox
        var $composeTextBody = $(".Am.Al:not(:has(iframe)), .LW-avf, .Am.Al > iframe", $composeContainer);
        $composeTextBody.addClass("b4c-save-selection");

        execute_javascript_on_document(function() {
            var textBody = by.get_frame().getElementsByClassName("b4c-save-selection")[0];
            by.selection.store(textBody.contentWindow || window);
        });

        $composeTextBody.removeClass("b4c-save-selection");
    });
}

function toggle_boomerang_calendar_button_menu(e, owner){
    var frameDoc = get_frame();
    var target = get_target(e);
    var b4cMenu = frameDoc.getElementById("b4c_menu");
    if (b4cMenu)
    {
        close_b4c_button_menu(e, owner);
    }
    else{
        //Add "clicked" style to button
        $("div", owner).addClass("T-I-Kq");

        var b4gContainer = document.createElement("ul");
        var b4gMenu = document.createElement("ul");

        b4gContainer.setAttribute("id","b4c_menu");
        b4gContainer.setAttribute("class","b4c_menu J-M");
        b4gContainer.setAttribute("style", "-webkit-user-select: none; min-width: 17em; min-height: auto; left:" + $(e.currentTarget).position().left + "px;");
        b4gContainer.setAttribute("role", "menu");
        b4gContainer.setAttribute("aria-haspopup", "true");
        b4gContainer.setAttribute("aria-activedescendant", "");

        b4gMenu = document.createElement("div");
        b4gMenu.setAttribute("id","b4g_inner_menu");
        b4gMenu.setAttribute("class","b4c_menu SK");
        b4gMenu.setAttribute("style","-webkit-user-select: none; font-size:12px;");

        var groupLoginUrl = "https://boomerangcalendar.baydin.com/group/grouplogin?guser=" + get_gmail_user();
        b4gMenu.innerHTML = "" +
            "<div id='b4c_create_event_menu' class='J-N b4c-menu-item' role='menu-item'><div class='J-N-Jz'>Create Event</div></div>" +
            "<div id='b4c_calendar_hide' class='J-N b4c-menu-item' role='menu-item'><div class='J-N-Jz'>Remove Formatting for This Email</div></div>" +
            "<div id='b4c_suggest_times_button' class='J-N b4c-menu-item' role='menu-item'><div class='J-N-Jz'>Suggest Meeting</div></div>" +
            "<div id='b4c_calendar_group_login' class='J-N b4c-menu-item' role='menu-item'><div class='J-N-Jz'>Plan Group Event</div></div>";

        b4gContainer.appendChild(b4gMenu);
        $(owner).parent().append(b4gContainer);

        $(".b4c-menu-item").hover(
            function(){ $(this).addClass("J-N-Je J-N-JT"); },
            function(){ $(this).removeClass("J-N-Je J-N-JT"); }
        );

        $("#b4c_calendar_hide", frameDoc).click(unhighlight_meeting_times);
        $("#b4c_create_event_menu", frameDoc).click(display_create_event_dialog);
        $("#b4c_suggest_times_button", frameDoc)
            .mousedown(function() {
                var $composeContainer = $(this).closest(".aeJ,.ar4").find(".I5,.fN");

                if($composeContainer.length <= 0) { return; } // Reply window isn't open

                // For pre-pop-in compose: ".Am.Al:not(:has(iframe))" for HTML compose, plain text is handled later
                // For new pop-in compose: ".LW-avf" for chrome and ".Am.Al > iframe" for firefox
                var $composeTextBody = $(".Am.Al:not(:has(iframe)), .LW-avf, .Am.Al > iframe", $composeContainer);
                $composeTextBody.addClass("b4c-insert-text-here");

                $(this).data("compose-container", $composeContainer);
            })
            .click(function() {
                suggest_times_link_clicked($(this).data("compose-container"));
            })
        ; $('#b4c_calendar_group_login', frameDoc).click(function(){ window.open(groupLoginUrl); });

        $("#b4c_suggest_times_button", frameDoc).click(function() {
            track_event("suggest-time-link", "click-email-menu", (is_pop_out_window() ? "pop-out" : "main"));
        });
        $("#b4c_calendar_hide", frameDoc).click(function() { track_event("removing-formatting-menu", "click"); });
        $("#b4c_create_event_menu", frameDoc).click(function() { track_event("create-event-menu", "click"); });


        $(frameDoc).bind('click', {owner: owner}, b4c_menu_frameDoc_click_handler);
    }
}

function close_b4c_button_menu(e, owner){ var frameDoc = get_frame();
var b4cMenu = frameDoc.getElementById("b4c_menu");

    //Since there are two boomerang buttons, we don't want to try to call removeChild
    //on a button that doesn't own the b4cMenu
    if(b4cMenu != null && b4cMenu.parentNode === owner)
    {
        //Remove "clicked" style from button
        $("div", owner).removeClass("J-Zh-I-JO");
        $("div", owner).removeClass("J-Zh-I-Kq");
        //Remove the menu from the DOM
        owner.removeChild(b4cMenu);
    }

    $(".by-datepicker").css("display", "none");

    if(b4cMenu != null && b4cMenu.parentNode === owner.parentNode)
    {
            //Remove "clicked" style from button
            $("div", owner).removeClass("J-Zh-I-JO");
            $("div", owner).removeClass("J-Zh-I-Kq");
            //Remove the menu from the DOM
            owner.parentNode.removeChild(b4cMenu);
    }
    //Remove "clicked" style from button
    if (owner) {
        $("div", owner).removeClass("T-I-Kq");
    }
}

function b4c_menu_frameDoc_click_handler(e)
{
    var frameDoc = get_frame();
    var target = get_target(e);

    // Do nothing if we click the menu itself, or any of the other menu options
    if(target.className.indexOf("ui") !== 0 &&
    target.className.indexOf("f") !== 0 &&
    target.className.indexOf("VP5otc-d2fWKd") === -1 &&
    target.className.indexOf("menu-anchor") === -1 &&
    target.className.indexOf("b4c_menu") === -1 &&
    target.className.indexOf("menu-caption") === -1 &&
    $(target).closest(".boomerang-calendar-button,.b4c_button").length === 0
    )
    {
        close_b4c_button_menu(e, e.data.owner);
        $(frameDoc).unbind('click', b4c_menu_frameDoc_click_handler);
    }
}

// Opens the top menu when clicked
function open_top_menu_gmail_black_bar(elt)
{
    var frameDoc = get_frame();
    var opened_menu = $("#boomerang-calendar-menu", frameDoc);
    if (opened_menu.length > 0){
        elt.removeClass("gbto");
        $(opened_menu).remove();
        $("#b4c_manage",frameDoc)
            .css("border-top", "none")
            .find(".gbts").css("border-bottom","none");
        return;
    }

    $("#b4c_manage",frameDoc).find(".gbts").css("border-bottom","1px solid white");

    elt.addClass("gbto");
    var groupLoginUrl = "https://boomerangcalendar.baydin.com/group/grouplogin?guser=" + get_gmail_user();
    var top_menu= document.createElement("div");
    top_menu.setAttribute("class","gbm manage_menu");
    top_menu.setAttribute("id","boomerang-calendar-menu");

    var top_menu_html = "<div class='gbmc'>"+
        "<ol class='gbmcc'> " +
        "<li class='gbkc gbmtc'><a class='gbmt top_menu_option' target='_blank' id='b4c_view_calendar_menu'>View My Calendar</a></li>" +
        "<li class='gbkc gbmtc'><a class='gbmt top_menu_option' target='_blank' id='b4c_calendar_group_login' href='" + groupLoginUrl + "'>Plan Group Event</a></li>" +
        "<li class='gbkc gbmtc'><a class='gbmt top_menu_option' target='_blank' id='b4c_calendar_sync'>Settings</a></li>" +
        "<li class='gbkc gbmtc'><a class='gbmt top_menu_option' target='_blank' id='b4c_calendar_intro'>Help</a></li>" +
        "<li class='gbkc gbmtc'><a class='gbmt top_menu_option' target='_blank' id='b4c_send_feedback' href='mailto:feedback+boomerangcalendar@baydin.com?subject=Boomerang%20Calendar%20Feedback' >Send Feedback</a></li>";

    top_menu_html += "</ol></div>";
    top_menu.innerHTML = top_menu_html;

    $("#b4c_manage", frameDoc).after($(top_menu));
    $("#b4c_calendar_sync").click(show_sync_dialog);
    $("#b4c_calendar_intro", frameDoc).click(display_intro_dialog);
    var isBlocked = read_from_localStorage(LOCAL_STORAGE_BLOCK_THIS_ACCOUNT) === "true";
    if (isBlocked){
        $("#b4c_calendar_intro", frameDoc).text("Help (Re-enable Boomerang Calendar)");
    }
    $("#b4c_view_calendar_menu", frameDoc).click(show_read_only_calendar_dialog);

    // Analytics
    $("#b4c_calendar_sync", frameDoc).click(function() { track_event("settings-menu", "click"); });
    $("#b4c_calendar_group_login", frameDoc).click(function() { track_event("plan-group-menu", "click"); });
    $("#b4c_calendar_intro", frameDoc).click(function() { track_event("help-menu", "click"); });
    $("#b4c_send_feedback", frameDoc).click(function() { track_event("feedback-menu", "click"); });
    $("#b4c_calendar_hide", frameDoc).click(function() { track_event("removing-formatting-menu", "click"); });
    $("#b4c_view_calendar_menu", frameDoc).click(function() { track_event("readonly-calendar-menu", "click"); });

    //top_menu.setAttribute("style", "visibility: visible; width: 260px; left: 0px; top:30px; border-top-width: none;");
    
    if (is_new_googlebar()){
        top_menu.setAttribute("style", "visibility: visible; width: 260px; left: 0px; border-top-width: none;top:30px;");
        $('#b4c_manage',frameDoc).css("border-top", "1px solid #BEBEBE");
    }

    $('.top_menu_option',frameDoc).mouseover(function (){
        $(this).addClass("gbmt-hvr");
        }).mouseleave(function (){
        $(this).removeClass("gbmt-hvr");
    });

    $(frameDoc).click(function(e){
        var target = get_target(e);

        if ($(target).parents().andSelf().filter("#b4c_manage").length === 0)
        {
            $("#b4c_manage",frameDoc).css("border-top", "none");
            $("#b4c_manage",frameDoc).removeClass("gbto");
            $(top_menu).remove();
            $("#b4c_manage",frameDoc).find(".gbts").css("border-bottom","none");

            $(frameDoc).unbind('click');
        }
    });

    $(top_menu).appendTo("#b4c_manage").css({
    	top: $("#b4c_manage").offset().top + $("#b4c_manage").height() - 2,
     	left: 0
    }).find("li > .gbmt").attr("style", "color: black !important; font-weight: bold;");
}

function open_top_menu_chrome_bar(elt){
    var frameDoc = get_frame();
    var opened_menu = $(".b4c_manage_dropdown", frameDoc);
    if (opened_menu.length > 0){
        $(opened_menu).remove();
        return;
    }
    var groupLoginUrl = "https://boomerangcalendar.baydin.com/group/grouplogin?guser=" + get_gmail_user();
    var manageLinks =
        "<ul style='list-style-type: none; line-height: 1.8em; padding: 0px 10px; margin-top: 10px; margin-bottom: 10px;'> " +
        "<li><a class='top_menu_option' target='_blank' id='b4c_view_calendar_menu'>View My Calendar</a></li>" +
        "<li><a class='top_menu_option' target='_blank' id='b4c_calendar_group_login' href='" + groupLoginUrl + "'>Plan Group Event</a></li>" +
        "<li><a class='top_menu_option' target='_blank' id='b4c_calendar_sync'>Settings</a></li>" +
        "<li><a class='top_menu_option' target='_blank' id='b4c_calendar_intro'>Help</a></li>" +
        "<li><a class='top_menu_option' target='_blank' id='b4c_send_feedback' href='mailto:feedback+boomerangcalendar@baydin.com?subject=Boomerang%20Calendar%20Feedback' >Send Feedback</a></li>" +
        "</ul>";


    var top_menu = $('<div class="b4c_manage_dropdown manage_menu" style="display: block; width:200px; margin-left:-5px; left:-15px; background: #fff; border: 1px solid #ccc; border-color: rgba(0,0,0,.2); box-shadow: 0 2px 10px rgba(0,0,0,.2); overflow: hidden; position: absolute; right: 0; top: 44px; -webkit-animation: gb__a .2s; animation: gb__a .2s; -webkit-border-radius: 2px; border-radius: 2px; -webkit-user-select: text; ">' + 
            manageLinks +
        '</div>'+
        '<div class="b4c_manage_dropdown" style="display:block; left:auto; margin-left:5px; border-color: transparent;border-style: dashed dashed solid;border-width: 0 8px 8px;position: absolute;z-index: 1;height: 0;width: 0;-webkit-animation: gb__a .2s;animation: gb__a .2s;border-bottom-color: #ccc;border-bottom-color: rgba(0,0,0,.2);top: 36px;"></div>' +
        '<div class="b4c_manage_dropdown" style="display:block; left:auto; margin-left:5px; border-color: transparent;border-bottom-color: #fff;border-style: dashed dashed solid;border-width: 0 8px 8px;position: absolute;top: 37px;z-index: 1;height: 0;width: 0;-webkit-animation: gb__a .2s;animation: gb__a .2s;"></div>'
        )

    topMenuLinks = top_menu.find("a");
    topMenuLinks.css("color", "#36c")
    topMenuLinks.css("text-decoration","none");
    topMenuLinks.css("cursor","pointer");
    topMenuLinks.hover(function() {
        $(this).css("text-decoration", "underline");
    }, function() {
        $(this).css("text-decoration", "none");
    });
    top_menu.appendTo("#b4c_manage");

    $("#b4c_calendar_sync").click(show_sync_dialog);
    $("#b4c_calendar_intro", frameDoc).click(display_intro_dialog);
    var isBlocked = read_from_localStorage(LOCAL_STORAGE_BLOCK_THIS_ACCOUNT) === "true";
    if (isBlocked){
        $("#b4c_calendar_intro", frameDoc).text("Help (Re-enable Boomerang Calendar)");
    }
    $("#b4c_view_calendar_menu", frameDoc).click(show_read_only_calendar_dialog);

    // Analytics
    $("#b4c_calendar_sync", frameDoc).click(function() { track_event("settings-menu", "click"); });
    $("#b4c_calendar_group_login", frameDoc).click(function() { track_event("plan-group-menu", "click"); });
    $("#b4c_calendar_intro", frameDoc).click(function() { track_event("help-menu", "click"); });
    $("#b4c_send_feedback", frameDoc).click(function() { track_event("feedback-menu", "click"); });
    $("#b4c_calendar_hide", frameDoc).click(function() { track_event("removing-formatting-menu", "click"); });
    $("#b4c_view_calendar_menu", frameDoc).click(function() { track_event("readonly-calendar-menu", "click"); });

    $(frameDoc).click(function(e){
                var target = get_target(e);
                if ($(target).parents().andSelf().filter("#b4c_manage").length === 0)
                {
                    $(top_menu).remove();
                    $(frameDoc).unbind('click');
                    }
            });
}


function display_intro_dialog(){
    show_intro_screen(1);
    track_event("intro-dialog", "show");
}

function show_authentication_error(){
    show_intro_screen(101);
}

function show_intro_screen(screen_no){
    show_intro_screen.lastScreenShown = (new Date()).getTime();
    track_event("intro-screen", "show", screen_no);

    var wc_msg = "";
    var wc_msg_text = "";
    var authTimeoutId = null;

    switch(screen_no) {
        case 1: {
            if (!UserClearedLocalStorage){
                wc_msg="<div id='bcal_wc_screen'> <div class='bcal_wc_header'>Thank you for installing Boomerang Calendar.</div> <div class='bcal_wc_text'><p>Boomerang Calendar makes managing your schedule, coordinating with others, and planning group events a snap - all from within your email!</p></div> <div class='bcal_wc_text'><p>To get started, Boomerang Calendar needs your permission to sync with the Google Calendar associated with <strong>"+ get_gmail_user() +"</strong>.</p></div></div><br/><br/><div class='bcal_wc_pg_no'>1 of 4 <span class='bcal_startButton button red' style='margin-left: 350px;'>START</span><a class='no_permission button' href='#'>SKIP</a> </div></div><br/><br/>";
            }
            else{
                wc_msg="<div id='bcal_wc_screen'> <div class='bcal_wc_header'>Did you clear your browsing data?</div> <div class='bcal_wc_text'><p>Boomerang Calendar needs to re-sync with the server. Click the button below to authenticate and download your information again.</p></div> <div class='bcal_wc_text'><p>If you are using private browsing or your browser is set to delete browsing data on close, you will see this screen every time you sign into Gmail. <a target='_blank' href='http://support.mozilla.org/en-US/kb/Private-Browsing'>Click here</a> for instructions on how to disable these settings.</p></div></div><br/><br/><div class='bcal_wc_pg_no'>1 of 4 <span class='bcal_startButton button red' style='margin-left: 350px;'>START</span><a class='no_permission button' href='#'>SKIP</a> </div></div><br/><br/>";
                UserClearedLocalStorage = false;
            }
        } break;
        case 2: {
            wc_msg="<div id='bcal_wc_screen'> <div class='bcal_wc_header'>Connecting with Google Calendar</div> <div id='bcal_already_authenticated_text' class='bcal_wc_text'>Loading Google's Authentication window... make sure to click the <em>Accept</em> button. </div> <div><p class='bcal_wc_img_header'></p><div align='center'><img class='bcal_wc_screenshot' width='355px' height='425px' src='" +get_wc_accounts_screenshot_url() + "' /></div><br/></div><div class='bcal_wc_pg_no'>2 of 4 <a class='skipButton button no_permission' href='#' style='display:none;'>SKIP</a> </div></div>";
            write_to_localStorage(LOCAL_STORAGE_BLOCK_THIS_ACCOUNT, "false");
            var url = "https://boomerangcalendar.baydin.com/checklogin?guser=" + get_gmail_user();
            authTimeoutId = setTimeout(function() {send_get_request_auth_wrapper(url, function(data){
                if (data === "Yes."){
                    $("#bcal_already_authenticated_text").text("You're all set! Click Next.");
                    show_intro_screen(3);
                    run_boomerang_meetings();
                }
            });},500);
            setTimeout(function() { $('.no_permission').show(); }, 3000);
        } break;
        case 3: {
            var message = "<div id='b4c-settings' style='margin: 10px 40px 50px 40px;'>Loading calendar list...</div>";
            wc_msg="<div id='bcal_wc_screen'> <div class='bcal_wc_header'>Set up Boomerang Calendar</div><div class='bcal_wc_text'>Pick which calendars you want to sync, and choose which calendar you want to use as the default. You can change this later - look for Settings under the Boomerang Cal menu.</div>"+ message +"<div class='bcal_wc_pg_no'>3 of 4 <span class='nextButton button green' style='margin-left: 360px;'>NEXT</span><a class='skipButton button' href='#'>SKIP</a> </div></div>";
        } break;
        case 4: {
            wc_msg="<div id='bcal_wc_screen'> <div class='bcal_wc_header'>3 Ways to Use Boomerang Calendar</div><div><ol><li> <span class='bcal_wc_text'>" +
            "<strong>Preview and add meetings</strong></span><p class='bcal_wc_description'> Boomerang Calendar detects meeting times inside your email. Hover to glance at your schedule, or click to see the event in a calendar view.</p><div align='center' style='margin-top: 10px;'><img class='bcal_wc_screenshot' width='420px' height='101px' src='"+ get_wc_highlight_email_screenshot_url() + "' /></div></li><br/>" +
            "<li><span class='bcal_wc_text'><strong>Propose a new event</strong></span><p class='bcal_wc_description'> When you're setting up a meeting, click the Suggest Times to Meet link to set up times and locations by clicking in your calendar.</p><div align='center' style='margin-top: 10px;'><img class='bcal_wc_screenshot' width='556px' height='85px' src='"+ get_wc_suggest_times_screenshot_url() +"' /></div></li><br/>" +
            "<li><span class='bcal_wc_text'><strong>Plan a group meeting</strong></span><p class='bcal_wc_description'> Ask participants which times they can make, so that you get the highest attendance. They don't need to be using Boomerang Calendar to reply.</p><div align='center' style='margin-top: 10px;'><img class='bcal_wc_screenshot' width='537px' height='100px' src='"+ get_wc_bcal_menu_screenshot_url() +"' /></div></li><br/>" +
            "</ul> </div><br/> </div><div class='bcal_wc_pg_no'>4 of 4</div> <span class='previousButton button last'>BACK</span><a class='skipButton button green' href='#'>FINISH</a> </div></div>";
        } break;
        case 101: {
            if (!BoomerangIsHavingTroubleAuthenticating){
                wc_msg="<div id='bcal_wc_screen'> <div class='bcal_wc_header'>Connecting with Google Calendar</div> <div class='bcal_wc_text'><p>It looks like you didn't click the <i>Allow</i> button.</p> <p>Boomerang Calendar will NOT work properly without connecting to your Google Calendar. Please click <i>Connect to Google Calendar</i> button below to give your permission.</p> <p><span class='bcalToAuthPage button green'>Connect to Google Calendar</span></p></div><div class='bcal_wc_pg_no'><a class='no_permission button' href='#'>SKIP</a></div></div>";
                BoomerangIsHavingTroubleAuthenticating = true;
            }
            else{
                wc_msg="<div id='bcal_wc_screen'> <div class='bcal_wc_header'>Do you have third-party cookies disabled?</div> <div class='bcal_wc_text'><p>Boomerang Calendar is having trouble authenticating.</p> <p>Do you have third-party cookies disabled? Please enable them. For more information about enabling third-party cookies, <a target='_blank' href='" + get_third_party_cookies_help_link() + "'>click here</a>.</p><p> After enabling third-party cookies, click the button below to connect.</p> <p><span class='bcalToAuthPage button green'>Connect to Google Calendar</span></p></div><div class='bcal_wc_pg_no'><a class='skipButton button' href='#'>SKIP</a></div></div>";
            }
        } break;
        case 100: {
            wc_msg="<div id='bcal_wc_screen'> <div class='bcal_wc_small_header'>Do you want to <strong>permanently disable</strong> Boomerang Calendar on this email, <strong>" + get_gmail_user() +"</strong>?</div> <div class='bcal_wc_text'>If you disable, you will not be able to use Boomerang Calendar on this email address in this browser.</div><br/><div><span class='bcalTutorialQuit button red'>Yes, disable permanently on "+ get_gmail_user() +"</span><a class='startOver button green' href='#'>No, I want to use Boomerang Calendar</a> </div></div>";
        } break;
        default:
            track_event("intro-screen", "screen-not-found", screen_no);
    }

    var frameDoc = get_frame();
    $(".bcal_dialogdiv").remove();
    var dialog = "<div class='bcal_dialogdiv' style='display:none;'>"+ wc_msg +"</div>";

    $("body", frameDoc).append($(dialog));

    $(".bcal_dialogdiv",frameDoc)
        .dialog({
            modal: true,
            closeOnEscape: true,
            width: 770,
            height: "auto",
            dialogClass: 'bcal-welcomeDialog'
        })


    $('.no_permission').click(function () {
        if (authTimeoutId != null){
            clearTimeout(authTimeoutId);
        }
        show_intro_screen(100);
    });
    $('.nextButton').click(function(){
        if (authTimeoutId != null){
            clearTimeout(authTimeoutId);
        }
        show_intro_screen(screen_no+1);
    });
    $('.previousButton').click(function(){
        show_intro_screen(screen_no-1);
    });

    $('.bcalToAuthPage').click(function(){
        show_intro_screen(2);
    });

    $('.bcalTutorialQuit').click(function(){
        $('.bcal_dialogdiv').dialog('close');
        window.alert("If you change your mind later, you can re-enable by clicking 'Help' in the Boomerang Cal menu.");
        quit_boomerang_meetings();
        track_event("intro-dialog", "disable-bcal");
    });

    $('.startOver').click(function(){
        show_intro_screen(1);
    });

    $('.bcal_startButton').click(function(){
        show_intro_screen(2);
    });
    $('.skipButton').click(function () {
        $('.bcal_dialogdiv').dialog('close');
    });

    $(".button:contains('SKIP')").click(function() {
        var elapse = "???", now = (new Date()).getTime();
        if(show_intro_screen.lastScreenShown) {
            elapse = now - show_intro_screen.lastScreenShown;
        }
        track_event("intro-screen", "skip", screen_no, ($(this).is(".no_permission") ? "no-permissions" : elapse));
    });

    if (screen_no == 3){
        var url = "https://boomerangcalendar.baydin.com/getsettings";
        send_get_request_auth_wrapper(url, function(data){
            var parsedData = $.parseJSON(data);
            var $syncSettings = $(by.template.syncSettings);
            var syncCalendars = parsedData["calendars"];
            for (var i=0; i < syncCalendars.length; i++){
                var calendar = syncCalendars[i];
                var $syncSetting = $(by.template.calendar_sync_option);
                $syncSetting.find(".bcalSummary").text(calendar["summary"]);
                $syncSetting.find(".calendar_sync").attr("value", calendar["id"]);
                if (calendar.isSynced){
                    $syncSetting.find(".calendar_sync").prop("checked", true);
                }
                $(".b4c_sync_list", $syncSettings).append($syncSetting);

                if (calendar.accessRole == "writer" || calendar.accessRole == "owner"){
                    var $defaultSetting = $(by.template.calendar_default_to_add);
                    if (calendar.isDefault){
                        $defaultSetting.prop("checked", true);
                    }
                    $defaultSetting.text(calendar["summary"]);
                    $defaultSetting.attr("value", calendar["id"]);
                    $(".b4c_def_list", $syncSettings).append($defaultSetting);
                }
            }
            $('#def_calendar',$syncSettings).change(function () {
                var url = "https://boomerangcalendar.baydin.com/setdefault?id=" + $(this).val();
                send_get_request_auth_wrapper(url, function(){});
            });
            
            $(".calendar_sync", $syncSettings).change(function () {
                var url = "https://boomerangcalendar.baydin.com/togglesync?id=" + $(this).val();
                send_get_request_auth_wrapper(url, function(){});
            });
            $(".bcal_dialogdiv",frameDoc).find("#b4c-settings").html($syncSettings);
        });
    }
}

function highlight_meeting_times()
{
    var frameDoc = get_frame();
    var messageBodies = $(MESSAGE_BODY + ":not(."+ EMAIL_ALREADY_SCANNED_CLASS +")", frameDoc).filter(":visible");

    delete_gmail_add_to_calendar_tooltip();

    messageBodies.each(function(){
        var messageBody = $(this);
        messageBody.addClass(EMAIL_ALREADY_SCANNED_CLASS);

        delete_gmail_add_to_calendar_ui(messageBody);

        var isGroupEvent = $("div[name='boomerang-group-event-identifier']", messageBody).length >0;
        if (!isGroupEvent){ // this is not an email we generated

            var messageBodyHtml = messageBody.html().substr(0, MAXIMUM_CHARACTERS_TO_READ);
            var messagePlainText = B4CCH24(messageBodyHtml);

            var timeMatches = ETFMT11(messagePlainText);
            var dateMatches = EDFMT10(messagePlainText);

            track_event("time-detection", "highlight", "count", timeMatches.length, true);
            track_event("date-detection", "highlight", "count", dateMatches.length, true);

            messageBody.find("*")
                .replaceText(GETD30(), function(match){ return "<span class='boomerang-end-time'>" + match + "</span>"; })
                .replaceText(GETD31(), function(match){ return "<span class='boomerang-time-zone'>" + match + "</span>"; })
                .replaceText(get_international_time_zone_decider(), function(match){ return "<span class='boomerang-time-zone'>" + match + "</span>"; })
            ;

            var eventLinks = [];
            while (timeMatches.length > 0 && dateMatches.length > 0 && !(all_linked(timeMatches) && all_linked(dateMatches))){
                var allPossibleEvents = get_all_possible_events(timeMatches, dateMatches);
                allPossibleEvents = remove_already_linked_events(allPossibleEvents);
                allPossibleEvents = CALLS18(allPossibleEvents, messagePlainText);

                var mostLikelyEvent = CMLE19(allPossibleEvents);
                mark_event_elements_as_linked(mostLikelyEvent);

                eventLinks.push(mostLikelyEvent);
            }

            var unhighlightedEmailText = messageBody.find("*");
            for (var i=0; i< Math.min(eventLinks.length, MAXIMUM_EVENTS_TO_TRACK); i++)
            {
                unhighlightedEmailText = unhighlightedEmailText.not(".boomerang-meeting-text, .boomerang-end-time");
                var eventLink = eventLinks[i];
                var dateMatch = eventLink["date"];
                var timeMatch = eventLink["time"];
                var dateStr = $.trim(dateMatch["theMatch"]);
                var timeStr = $.trim(timeMatch["theMatch"]);

                var eventText = GSBAIM16(dateMatch, timeMatch, messagePlainText);

                var wordCount = CTIS21(/\w+/g, eventText);

                if (wordCount < 10 && ETISMB20(messageBody, eventText)){
                    unhighlightedEmailText.replaceText($.trim(eventText), function(match){
                        return wrap_event_meeting_tag_around_text(match, i, dateStr, timeStr, false);
                    });
                }
                else{
                    unhighlightedEmailText.replaceText(timeStr, function(match){
                        return wrap_event_meeting_tag_around_text(match, i, dateStr, timeStr, false);
                    });
                    unhighlightedEmailText.replaceText(dateStr, function(match){
                        return wrap_event_meeting_tag_around_text(match, i, dateStr, timeStr, false);
                    });
                }
            }


            // If there are no events, set all date matches to all day events.
            if (eventLinks.length === 0){
                for (var i=0; i<dateMatches.length; i++){
                    var unhighlightedEmailText = messageBody.find("*").not(".boomerang-meeting-text").not(".boomerang-end-time");
                    var dateMatch = dateMatches[i];
                    var dateStr = $.trim(dateMatch["theMatch"]);
                    var truncatedCurrentTime = new Date().set({minute: 0, second: 0 }).toString("h:mm tt");
                    unhighlightedEmailText.replaceText(dateStr, function(match){return wrap_event_meeting_tag_around_text(match, i, dateStr, truncatedCurrentTime, true);});
                }
            }

        }
        else{ // special rules if this is our group event email
            var groupInviteChoices = messageBody.find("div[name='boomerang-group-event-choice']");
            var timeSlotChoice = $("div[name]", groupInviteChoices);
            var i = 0;
            timeSlotChoice.each(function(){
                var thisChoice = $(this);
                var dateName = thisChoice.attr("name");
                var dateParts = dateName.split(";");
                var dateStr = dateParts[0];
                var timeStr = dateParts[1];
                var endTime = dateParts[2];
                var wrapped_event = "<div>" + wrap_event_meeting_tag_around_text(thisChoice.html(), i, dateStr, timeStr, false);
                wrapped_event += "<span class='boomerang-end-time' style='display:none'>" + endTime + "</span></div>";
                thisChoice.replaceWith(wrapped_event);
                i++;
            });
        }

        if (!boomerang_css_exists_in_framedoc()){
            add_css_to_iframe();
        }
        if(!css_exists_in_root_document()) {
            add_css_to_root_document();
        }

        var displayImagesBelowButton = messageBody.parent().find(DISPLAY_IMAGES_BELOW_SELECTOR);
        displayImagesBelowButton.click(function(){
            setTimeout(function(){ messageBody.removeClass(EMAIL_ALREADY_SCANNED_CLASS); }, 2000);
        });

        $(messageBody)
            .mousedown(function(){
                $(this).mouseup(function(){
                    var selectedNode = get_user_highlighted_node();
                    remove_b4c_highlighting_from_selection(selectedNode);
                    $(this).unbind("mouseup");
                });
            })
            .click(restore_b4c_highlighting)
            .find(".boomerang-meeting-text")
                .hoverIntent(b4c_availability_hover, b4c_availability_hover_close)
                .hover(
                    function(){ // mouseover event
                        $(this).css("text-decoration", "underline");
                    },
                    function(){ //mouseout event
                        $(this).css("text-decoration", "none");
                    }
                )
                .click(function(){
                    display_add_event_dialog($(this), "meeting-text");
                    track_event("add-event", "click", "meeting-text");
                })
            .end()
            .find(".b4c-event").each(function(){
                var clickedMeeting = $(this);
                var meetingTime = determine_meeting_time_from_clicked_jqueryized_highlighted_text(clickedMeeting, messagePlainText);

                var startTime = meetingTime["startTime"];
                var endTime = meetingTime["endTime"];
                var allDay = meetingTime["allDay"];
                var allDayBoolean = false;
                if (allDay === "true"){
                    allDayBoolean = true;
                }

                var busyStatus = get_cached_free_busy(startTime, endTime, allDayBoolean);
                $(".boomerang-meeting-text",clickedMeeting).addClass(busyStatus);
                $(this).attr("b4c_busy_status", busyStatus);
            })
        ;

        // Additional Group Meeting logic
        var groupInviteChoices = messageBody.find("div[name='boomerang-group-event-choice']");
        groupInviteChoices.each(function(){
            var groupInviteChoice = $(this);
            var groupEventStatus = groupInviteChoice.find(".b4c-event").last().attr("b4c_busy_status");
            try{
                if (groupEventStatus.indexOf("green") >= 0){
                    groupInviteChoice.find("input[value='yes']") // Checkbox
                        .prop('checked', true)
                        .next('label').css("background-color", "#FFC")
                    ;
                }
                else if (groupEventStatus.indexOf("red") >= 0){
                    groupInviteChoice.find("input[value='no']") // Checkbox
                        .prop('checked', true)
                        .next('label').css("background-color", "#FFC")
                    ;
                }
                else if (groupEventStatus.indexOf("yellow") >= 0){
                    groupInviteChoice.find("input[value='maybe']") // Checkbox
                        .prop('checked', true)
                        .next('label').css("background-color", "#FFC")
                    ;
                }
            }
            catch(error){ }
        });

        var groupOrganizerTable = messageBody.find("table[name='boomerang-group-event-organizer-choices']");
        if (groupOrganizerTable.length > 0){
            var groupOrganizerButtons = $("tr[name='boomerang-group-event-organizer-buttons'] td", groupOrganizerTable);
            groupOrganizerButtons.each(function(){
                var groupOrganizerButton = $(this);
                var buttonName = groupOrganizerButton.attr('name');
                var buttonNum = buttonName.replace("boomerang-group-event-organizer-choice-", "");
                var correspondingEvent = $(".b4c_event_id" + buttonNum, messageBody);
                groupOrganizerButton.html("<button class='boomerang-group-event-reply-all' timeChosen='"+ correspondingEvent.text() +"'>Choose Time and Notify Recipients</button>");
            });
            $(".boomerang-group-event-reply-all", messageBody).click(function(){
                var timeChosen = $(this).attr("timeChosen");
                var chosenEventNum = $(this).parent().attr("name").replace("boomerang-group-event-organizer-choice-", "");
                var chosenEventPlus = $("[b4c_id='" + chosenEventNum + "']");
                display_add_event_dialog(chosenEventPlus, "group-event", after_adding_event);
                function after_adding_event(){
                    open_reply_window();
                    prepend_html_to_draft("<div>Let's meet on " + timeChosen + ".</div>");
                }
            });
        }
    });
}

function unhighlight_meeting_times(){
    var frameDoc = get_frame();
    var b4c_texts = $(".boomerang-meeting-text", frameDoc);
    b4c_texts.removeClass("b4c-green b4c-red b4c-yellow b4c-black");

    var messageBodies = $(MESSAGE_BODY, frameDoc).filter(":visible");
    messageBodies.addClass(EMAIL_NEVER_HIGHLIGHT_CLASS);
}

function remove_b4c_highlighting_from_selection(selectedNode){
    var b4c_texts = $(".boomerang-meeting-text", selectedNode);
    b4c_texts.removeClass("b4c-green b4c-red b4c-yellow b4c-black");
}

function restore_b4c_highlighting(){
    var frameDoc = get_frame();
    var neverShowHighlight = $("." + EMAIL_NEVER_HIGHLIGHT_CLASS, frameDoc).length > 0;

    if (!neverShowHighlight){
        var b4c_texts = $(".boomerang-meeting-text", frameDoc);
        b4c_texts.each(function(){
            var meetingText = $(this);
            var meetingStatus = (meetingText.parent().attr("b4c_busy_status"));
            meetingText.addClass(meetingStatus);
        });
    }
}

function determine_notes_from_clicked_jquerized_highlighted_text(clickedMeetingTime){
    var messageBody = clickedMeetingTime.closest(MESSAGE_BODY);
    var notes = GPTOHFN26(messageBody.html());
    return notes;
}

function determine_sender_name_from_clicked_jqueryized_highlighted_text(clickedMeetingTime){
    var messageBody = clickedMeetingTime.closest(MESSAGE_BODY);
    var message = messageBody.parent();
    var senderName = $(".gD", message).text();
    senderName = senderName.replace("\u2706", ""); // replace weird phone symbol
    return senderName;
}
function determine_sender_email_from_clicked_jqueryized_highlighted_text(clickedMeetingTime){
    var messageBody = clickedMeetingTime.closest(MESSAGE_BODY);
    var message = messageBody.parent();
    var senderEmail = $(".gD", message).attr("email");
    return senderEmail;
}
function determine_recipient_name_from_clicked_jqueryized_highlighted_text(clickedMeetingTime){
    var guser = get_gmail_user();
    var messageBody = clickedMeetingTime.closest(MESSAGE_BODY);
    var message = messageBody.parent();
        var recipientName = $(".hb",message).text();
    recipientName = recipientName.replace("to ", "");
        return recipientName;
}
function determine_attendees_from_clicked_jqueryized_highlighted_text(clickedMeetingTime){
    var guser = get_gmail_user();
    var messageBody = clickedMeetingTime.closest(MESSAGE_BODY);

    var attendeeEmails = [];
    var participantDiv = messageBody.find("div[name='boomerang-group-event-participants']");
    if (participantDiv.length === 1){
            var participants = participantDiv.find("span");
            participants.each(function(){ attendeeEmails.push($(this).attr("name")); });
    }
    else{
        var message = messageBody.parent();
        var attendees = message.find("[email]");
        var attendeesNotIncludingMe = attendees.filter(function(){
            var email = $(this).attr("email");
            return $(this).text() !== "me" && email !== guser && email !== "boomerangcalendar@baydin.com";
        });
        attendeeEmails = attendeesNotIncludingMe.map(function(){return $(this).attr("email");}).get();
        attendeeEmails = eliminateDuplicatesAndNull(attendeeEmails);
    }
    return attendeeEmails;
}
function determine_location_from_clicked_jqueryized_highlighted_text(clickedMeetingTime){
    var messageBody = clickedMeetingTime.closest(MESSAGE_BODY);
    var messageBodyHtml = messageBody.html();
    var messageBodyText = B4CCH24(messageBodyHtml);
    var possibleLocations = ELFMT23(messageBodyText);
    possibleLocations = CUL28(possibleLocations);
    var location = possibleLocations[0];
    if (!location){
        location = "";
    }
    return location;
}


function determine_meeting_time_from_clicked_jqueryized_highlighted_text(clickedMeetingTime, messageBodyText){
    if(!messageBodyText) {
        var messageBodyHtml = clickedMeetingTime.closest(MESSAGE_BODY).html();
        messageBodyText = B4CCH24(messageBodyHtml);
    }

    var threadEmail = clickedMeetingTime.closest(MESSAGE_BODY).parent();
    var timestampText = $(".g3", threadEmail).attr("alt").replace(" at", "");
        var emailDate = new Date();
    if (get_gmail_language() === "English-US" || get_gmail_language() === "English-UK"){
        emailDate = Date.parse(timestampText);
    }

    var suggestionShouldBeAM = is_AM(messageBodyText);

    var eventDetails = clickedMeetingTime.closest(".b4c-event");
    var dateStrUnparsed = eventDetails.attr("b4c_date");
    var timeStrUnparsed = eventDetails.attr("b4c_time");
    var busyStatusStr = eventDetails.attr("b4c_busy_status");
    var allDay = eventDetails.attr("b4c_all_day");

    var dateStr = MDFMT13(dateStrUnparsed)[0];

    var timeStr = MTFMT14(timeStrUnparsed)[0];
    if (timeStr == null){
        // if the time string can't be parsed, it's probably in the form "\d",
        // so add minutes and retry
        timeStr = MTFMT14(timeStrUnparsed + ":00")[0];
    }

    var dayOfWeekStr = MDOWFMT15(dateStrUnparsed)[0];

    var startTime = convert_raw_date_strings_to_date(dateStr, timeStr, dayOfWeekStr, suggestionShouldBeAM, emailDate);
    var endTime = startTime.clone().addMinutes(get_preferences()["defaultMeetingTime"]);

    var connectedBoomerangEndTime = eventDetails.next(".boomerang-end-time");

    if (connectedBoomerangEndTime.length > 0){
        var endTimeStr = $(connectedBoomerangEndTime[0]).text();
        var possibleEndTime = convert_raw_date_strings_to_date(dateStr, endTimeStr, dayOfWeekStr, suggestionShouldBeAM, emailDate);
        if (possibleEndTime > startTime){
            endTime = possibleEndTime;
        }
    }

    var timeZone = eventDetails.next(".boomerang-time-zone");

    if (timeZone.length === 0){
        timeZone = eventDetails.next().next(".boomerang-time-zone");
    }

    var timeZoneOffset = b4c_time_zone_to_offset(timeZone.text(), startTime);
    startTime.setTimezoneOffset(timeZoneOffset);
    endTime.setTimezoneOffset(timeZoneOffset);

    return {"startTime": startTime, "endTime": endTime, "busyStatus" : busyStatusStr, "emailDate": emailDate, "allDay": allDay};
}

function get_all_events_on_the_page_sorted_by_priority(){
    var frameDoc = get_frame();
    var eventsJquery = $(".b4c-event:visible", frameDoc);
    var eventsArray = [];
    eventsJquery.each(function(){
        var event = determine_meeting_time_from_clicked_jqueryized_highlighted_text($(this));
        eventsArray.push(event);
    });
    function sort_events_with_green_first(eventsArray){
        eventsArray.sort(function (eventA, eventB) {
            var eventA_status = 0;
            var eventB_status = 0;
            if (eventA["busyStatus"] === "b4c-green"){
                eventA_status = 1;
            }
            if (eventB["busyStatus"] === "b4c-green"){
                eventB_status = 1;
            }
            return eventB_status - eventA_status;
        });
        return eventsArray;
    }
    eventsArray = sort_events_with_green_first(eventsArray);
    return eventsArray;
}

function wrap_event_meeting_tag_around_text(match, i, dateStr, timeStr, allDay){
    var calendarIcon = get_calendar_icon_url();
    var b4cEventId = i.toString();
    var b4cEventClass = "b4c_event_id" + b4cEventId;
    var allDayStr = "false";
    if (allDay){
        allDayStr = "true";
    }

    return "<span class='b4c-event' b4c_id='"+ b4cEventId +"' b4c_date='"+ dateStr +"' b4c_time='" + timeStr.replace("'" , "&#39;") + "' b4c_all_day='" + allDayStr +"'>" +
            "<span class='boomerang-meeting-text " + b4cEventClass + "'>" + match + "</span>" +
            "</span>";
}



/*availability hover dialog */

function b4c_availability_hover(e){
    var clickedMeetingTime = $(this);
    var x = e.pageX;
    var y = e.pageY;

    if (AbleToShowHoverDialog && !$(".b4c-availability-hover").is(":visible")){
        display_availability_dialog(clickedMeetingTime, x, y);
        track_event("availability-dialog", "show");

    }
}
/*availability hover dialog close on mouseout */
function b4c_availability_hover_close(e){
    var frameDoc = get_frame();
    var $dialog = $(".b4c-availability-hover");
    if($dialog.is(":visible")) {
        track_event("availability-dialog", "close");
    }
    $dialog.parent().mouseleave(function(){
            if($dialog.is(":visible")){
                $dialog.parent().remove();
            }
        }
    );
}


function display_availability_dialog(clickedMeetingTime,x, y){

    var meetingTime = determine_meeting_time_from_clicked_jqueryized_highlighted_text(clickedMeetingTime);
    var meetingTime_start = meetingTime["startTime"];
    var meetingTime_end = meetingTime["endTime"];
    var meetingTime_color = meetingTime["busyStatus"];
    var meetingTime_all_day = meetingTime["allDay"];

    var start_date = meetingTime_start.toString("ddd " + B4C_DISPLAY_NUM_DATE_FORMAT);

    if (meetingTime_all_day === "true"){
        meetingTime_start = meetingTime_start.clone().set({hour:0, minute:0, second:0});
        meetingTime_end = meetingTime_start.clone().set({hour:23, minute:59, second:0});
    }

    var frameDoc = get_frame();
    $(".b4c-availability-hover").remove();
    var last_updated = get_last_updated_time_for_ui();
    var message = "<p> <strong>Schedule for " + start_date + "</strong> as of "+ last_updated +"</p>";

    var events_by_day = get_cached_events_by_day(meetingTime_start);
    var clickedEventArray =[];
    var clickedEvent = {
        start: meetingTime_start,
        end: meetingTime_end,
        color: meetingTime_color,
        title: "Selected Time"
    };
    clickedEventArray.push(clickedEvent);
    events_by_day.push(clickedEventArray);


    events_by_day = sort_events_by_start_time(events_by_day);

    for (var i =0; i < events_by_day.length; i++){

        if(events_by_day[i][0]["title"] === "Selected Time"){
            message += "<div class='b4c_hovered_time "+ events_by_day[i][0]["color"] + "'>";
        }
        else {
            message +="<div>";
        }


        message += "<span class='start_time'>" + Date.parse(events_by_day[i][0]["start"]).toString("h:mm tt") + " - </span>";
        message += "<span class='end_time'>" + Date.parse(events_by_day[i][0]["end"]).toString("h:mm tt") + "</span> &nbsp &nbsp";

        message += "<span class='event_title'>" + events_by_day[i][0]["title"] + "</span></div>"; }


    var dialog = "<div class='bcal_dialogdiv b4c-availability-hover' id='b4c_availability' style='display:none;'>"+ message+"</div>";
    $("body", frameDoc).append($(dialog));

    $(".b4c-availability-hover",frameDoc).dialog({
        title: 'Availability Status',
        width: 450,
        modal: false,
        position: [x, y - 20],
        resizable: false,
        buttons: {
            "Add This Event": function() {
                display_add_event_dialog(clickedMeetingTime, "hover");
                track_event("availability-dialog", "click", "add-event-in-hover");
            },
            "Cancel": function() {
                $(this).dialog("destroy");
                track_event("availability-dialog", "click", "cancel");
            }
        }
    })
    .closest(".by-dialog")
        .find(":ui-button:contains(Show Calendar)").addClass("by-button-primary").end()
        .find(":ui-button:contains(Add This Event)").addClass("by-button-secondary").end();
}


function sort_events_by_start_time(eventsByDay){
    eventsByDay.sort(function (eventA, eventB) {
        var eventA_start = Date.parse(eventA[0]["start"]);
        var eventB_start = Date.parse(eventB[0]["start"]);
        return eventA_start - eventB_start;

    });
    return eventsByDay;
}

function sort_events_by_start_date_and_time(eventsArray){
    eventsArray.sort(function (eventA, eventB) {
        var eventA_start = Date.parse(eventA["meetingTime"]["startTime"]);
        var eventB_start = Date.parse(eventB["meetingTime"]["startTime"]);
        return eventA_start - eventB_start;
    });
    return eventsArray;
}

function sort_full_calendar_events(events) {
    events.sort(function (eventA, eventB){
        var eventA_start = Date.parse(eventA.start);
        var eventB_start = Date.parse(eventB.start);
        return eventA_start - eventB_start;
    });
    return events;
}




function rerender_b4c_calendar_after_cache_verification(b4c_calendar)
{
    b4c_calendar.fullCalendar('removeEvents', function(event){
        return !event["b4c_preserve_event_when_syncing"];
    });
    b4c_calendar.fullCalendar('addEventSource', get_all_events_from_local_storage());
    b4c_calendar.fullCalendar('rerenderEvents');
}

function attach_add_event_dialog_analytics($dialog, parent_name) {
    var track_addevent = function(action, value) {
        track_event("add-event-dialog-via-" + parent_name, action, value);
    };
    // store what the user changed to use when 'add event' button is pressed
    var date_fields_changed = {};

    $dialog
        .find("#start_date_input, #start_time_input, #end_date_input, #end_time_input")
            .change(function() {
                date_fields_changed[this.name] = true;  // imitating a set
            })
        .end() // success / cancel buttons
        .bind("event-added", function() {
            $(Object.keys(date_fields_changed)).each(function(_, field_changed) {
                track_addevent("field-modified-before-submit", field_changed);
            });

            track_addevent("event-added-successfully");
        })
        .bind("add-event-canceled dialogclose", function() {
            track_addevent("cancel");
        })
        .find("#b4c_timezone")
            .change(function() { track_addevent("time-zone-change"); })
        .end() // buttons below the note
        .find("#b4c_boomerang_select")
            .change(function() {
                track_addevent("boomerang-select-change", $(this).val());
            })
        .end()
        .find("#b4c_reminder_select")
            .change(function() {
                track_addevent("reminder-time-change", $(this).val());
            })
        .end()
        .find("#b4c_boomerang_cb")
            .change(function() {
                track_addevent("boomeranging-checkbox-change", String(this.checked));
            })
        .end()
        .find("#b4c_reminder_cb")
            .change(function() {
                track_addevent("reminder-checkbox-change", String(this.checked));
            })
        .end()
        .find("#b4c_google_invite_cb")
            .change(function() {
                track_addevent("add-more-recipients-change", String(this.checked));
            })
        .end()
        .find("#b4c_add_more_attendees_button")
            .click(function() {
                track_addevent("add-more-attendees-clicked", $(this).val());
            })
        .end();
}

function fill_out_add_event_form($dialog, eventTime, clickedBcalEvent)
{
    $("#start_date_input", $dialog).val(eventTime.startTime.toString("ddd " + B4C_DISPLAY_NUM_DATE_FORMAT));
    $("#start_time_input", $dialog).val(eventTime.startTime.toString("hh:mm tt"));
    $("#end_date_input", $dialog).val(eventTime.endTime.toString("ddd " + B4C_DISPLAY_NUM_DATE_FORMAT));
    var numDayDelta = Math.floor((eventTime.endTime.getTime() - eventTime.startTime.getTime())/(1000 * 60 * 60* 24));
    $("#end_date_input", $dialog).data('daydelta', numDayDelta);

    $("#end_time_input", $dialog).val(eventTime.endTime.toString("hh:mm tt"));
    $("#meeting_place_input", $dialog).val(clickedBcalEvent.location);
    $("#meeting_note_input", $dialog).val(clickedBcalEvent.notes);
    if(clickedBcalEvent.senderEmail === get_gmail_user()){
        $("#b4c_event_title", $dialog).val(clickedBcalEvent.recipientName + " - " + get_thread_subject());
    }
    else {
        $("#b4c_event_title", $dialog).val(clickedBcalEvent.senderName + " - " + get_thread_subject());
    }
    var timeZone = b4c_get_timezone(eventTime.startTime);
    $("#b4c_timezone").val(timeZone);
    $("#b4c_email_date", $dialog).val(eventTime.emailDate.toString(B4C_DISPLAY_NUM_DATE_FORMAT + " hh:mm tt"));
    $("#b4c_thread_id", $dialog).val(get_thread_id());

    //setting smart default for reminder dropdown
    var currentDay = new Date();

    var timeBeforeEvent = eventTime.startTime.getTime() - currentDay.getTime();
    var daysBeforeEvent = Math.ceil(timeBeforeEvent / (1000 * 60 * 60* 24));
    if (daysBeforeEvent >= 14 && daysBeforeEvent < 60 ){
        $("#b4c_reminder_select", $dialog).val("a day before");
        $("#b4c_boomerang_select", $dialog).val("a day before");
    }
    else if (daysBeforeEvent >= 60 && daysBeforeEvent < 270 ){
        $("#b4c_reminder_select", $dialog).val("a week before");
        $("#b4c_boomerang_select", $dialog).val("a week before");
    }
    else if (daysBeforeEvent >= 270){
        $("#b4c_reminder_select", $dialog).val("a month before");
        $("#b4c_boomerang_select", $dialog).val("a month before");
    }
    else {
        $("#b4c_reminder_select", $dialog).val("day of");
        $("#b4c_boomerang_select", $dialog).val("day of");
    }
    var attendeeString = construct_attendee_visual_blocks(clickedBcalEvent.attendees);
    $("#b4c_default_attendee_emails", $dialog).html(attendeeString);
    $("#b4c_inputted_attendee_emails", $dialog).html(attendeeString);
    $(".b4c_attendee_cancel", $dialog).click(function(){
        $(this).closest(".b4c_attendee_display_block").remove();
    });
}

function fill_out_create_event_form($dialog)
{
    $("#b4c_event_title", $dialog).val(get_thread_subject());
    $("#b4c_thread_id", $dialog).val( get_thread_id() || "#");
    $("#end_date_input", $dialog).data('daydelta', 0);

    //setting smart default for reminder dropdown
    var defaultStartTime = new Date();
    defaultStartTime.addDays(7);
    defaultStartTime.setSeconds(0);
    defaultStartTime.addMinutes(30);
    if (defaultStartTime.getMinutes() > 30){
        defaultStartTime.setMinutes(30);
    }
    else{
        defaultStartTime.setMinutes(0);
    }
    var defaultEndTime = defaultStartTime.clone().addMinutes(60);

    var timeZone = b4c_get_timezone(defaultStartTime);
    $("#b4c_timezone").val(timeZone);

    var b4cEventsOnThePage = get_all_events_on_the_page_sorted_by_priority();
    if (b4cEventsOnThePage.length === 0){
        $("#start_date_input", $dialog).val(defaultStartTime.toString("ddd " + B4C_DISPLAY_NUM_DATE_FORMAT));
        $("#start_time_input", $dialog).val(defaultStartTime.toString("hh:mm tt"));
        $("#end_time_input", $dialog).val(defaultEndTime.toString("hh:mm tt"));
        $("#end_date_input", $dialog).val(defaultEndTime.toString("ddd " + B4C_DISPLAY_NUM_DATE_FORMAT));
    }
    else{
        var defaultEvent = b4cEventsOnThePage[0];
        $("#start_date_input", $dialog).val(defaultEvent["startTime"].toString("ddd " + B4C_DISPLAY_NUM_DATE_FORMAT));
        $("#start_time_input", $dialog).val(defaultEvent["startTime"].toString("hh:mm tt"));
        $("#end_time_input", $dialog).val(defaultEvent["endTime"].toString("hh:mm tt"));
        $("#end_date_input", $dialog).val(defaultEvent["endTime"].toString("ddd " + B4C_DISPLAY_NUM_DATE_FORMAT));
    }

    var attendeeString = construct_attendee_visual_blocks(get_gmail_user());
    $("#b4c_default_attendee_emails", $dialog).html(get_gmail_user());
    $("#b4c_inputted_attendee_emails", $dialog).html(get_gmail_user());
    var emailDate = get_latest_email_sent_date_in_thread();

    if (emailDate){
        $("#b4c_email_date", $dialog).val(emailDate.toString(B4C_DISPLAY_NUM_DATE_FORMAT + " hh:mm tt"));
    }
    else {
        $("#b4c_boomerang_cb", $dialog).parent().hide();
    }

    $(".b4c_attendee_cancel").click(function(){
        $(this).closest(".b4c_attendee_display_block").remove();
    });
}

function callback_to_insert_calendar_selection(data){
    var calendarSelectionString = decodeURIComponent(data);
    var calendarSelectionJson = JSON.parse(calendarSelectionString);
    if(calendarSelectionJson.length === 0){
        var calendarSelectionHtml = "<option value=''>No calendar available</option>";
        $("#b4c_select_calendar").html(calendarSelectionHtml);
        $('#b4c_select_calendar').after("<div class='b4c_error'>Looks like you need to create a Google Calendar account associated with this email address. Click <a href='http://www.google.com/calendar' target='_blank'>here</a> and follow the steps.</div></br/>");
        $('.b4c_add_event_content').html("");
    }
    else{
        insert_calendar_selection(calendarSelectionJson);
    }
}

function insert_calendar_selection(calendarSelectionJson)
{
    var calendarSelectionHtml = "";
    for (var i=0; i<calendarSelectionJson.length; i++){
        var calendar = calendarSelectionJson[i];
        calendarSelectionHtml+= "<option value='" + calendar["calendarId"] +"'";
        if (calendar["isDefault"]){
            calendarSelectionHtml+= " selected='selected'";
        }
        calendarSelectionHtml+= ">";
        calendarSelectionHtml+= calendar["summary"];
        calendarSelectionHtml+= "</option>";
    }
    $("#b4c_select_calendar").html(calendarSelectionHtml);
}

function display_add_event_dialog(clickedMeetingTime, addevent_source, optional_add_event_callback){
    var clickedBcalEvent = {
        location: determine_location_from_clicked_jqueryized_highlighted_text(clickedMeetingTime),
        senderName: determine_sender_name_from_clicked_jqueryized_highlighted_text(clickedMeetingTime),
        senderEmail: determine_sender_email_from_clicked_jqueryized_highlighted_text(clickedMeetingTime),
        notes: determine_notes_from_clicked_jquerized_highlighted_text(clickedMeetingTime),
        recipientName: determine_recipient_name_from_clicked_jqueryized_highlighted_text(clickedMeetingTime),
        attendees: determine_attendees_from_clicked_jqueryized_highlighted_text(clickedMeetingTime)
    };
    var meetingTime = determine_meeting_time_from_clicked_jqueryized_highlighted_text(clickedMeetingTime);
        var eventTime = {};
        eventTime.startTime = meetingTime["startTime"];
        eventTime.endTime = meetingTime["endTime"];
    eventTime.emailDate = meetingTime["emailDate"];

    $(".bcal_dialogdiv").remove();
    var $dialog = init_add_event_dialog(addevent_source);
    fill_out_add_event_form($dialog, eventTime, clickedBcalEvent);

    $('.b4c-button-confirm', $dialog).click(function () {
        $dialog.trigger("event-added");
        add_event($(this).parentsUntil(".bcal_dialogdiv").parent());
        if (optional_add_event_callback){
            optional_add_event_callback();
        }
    });

    $('.b4c-button-cancel', $dialog).click(function () {
        $dialog.trigger("add-event-canceled");
        $(".bcal_dialogdiv").remove();
    });

    $dialog.dialog("open");
}

function init_add_event_dialog(source_page_name) {
    var frameDoc = get_frame();

    var $dialog = $(by.template.addEvent)
        .dialog({
            title: 'Add this event',
            width: 615,
            modal: false,
            resizable: false,
            autoOpen: false
        })
        .find("button").button().end()
    ;

    $(".b4c-show-end-date", $dialog).click(function(e) {
        e.preventDefault();

        $(this).hide().next(".b4c-end-date").show();
    });

    $(".b4c-edit-timezone-menu").remove();
    var $timezoneMenu = by.timezone.createMenu(function(err, offset) {
        $("#b4c-timezone").val(offset["minute-offset"]);
        $(".b4c-timezone-shortname").text(offset.abbreviation);
        by.timezone.updateMenu($timezoneMenu, offset["minute-offset"]);
    }).addClass("b4c-edit-timezone-menu").appendTo(document.body);

    $dialog.bind("dialogclose", function() { $timezoneMenu.remove(); });

    $(".b4c-edit-timezone", $dialog).click(function(e) {
        e.preventDefault();

        $(".by-menu").not($timezoneMenu).hide();
        $timezoneMenu.show().position({
            of: this,
            my: "left top",
            at: "left bottom"
        }).find(".timezone-search").focus();
    });

    $("#start_date_input", $dialog)
        .datepicker({
            showAnim: "fold",
            defaultDate: +7,
            dateFormat: B4C_DATEPICKER_FORMAT,
            onClose: function(dateText, inst){ $('#start_date_input').focus().change();}
        })
        .change(function(){
            var newStartDate = Date.parse($("#start_date_input").val());
            var newEndDateTime = new Date();
            var dayDelta = $('#end_date_input').data('daydelta');
            newEndDateTime = newStartDate.addDays(dayDelta);

            //newStartDate.getTime()+ (1000 * 60 * 60* 24 * $('#end_date_input').data('daydelta'));
            $("#end_date_input").val(newEndDateTime.toString("ddd " + B4C_DISPLAY_NUM_DATE_FORMAT));
        })
    ;
    $("#end_date_input", $dialog)
        .datepicker({
            showAnim: "fold",
            defaultDate: +7,
            dateFormat: B4C_DATEPICKER_FORMAT,
            onClose: function(dateText, inst){ $('#end_date_input').focus().change();}
        })
        .change(function(){
            var newEndDate = Date.parse($("#end_date_input").val());
            var currStartDate = Date.parse($("#start_date_input").val());
            var numDayDelta = Math.floor((newEndDate.getTime() - currStartDate.getTime())/(1000 * 60 * 60* 24));
            $("#end_date_input").data('daydelta', numDayDelta);
        })
    ;

        if(b4g_is_preview_pane()) {
        $("#b4c_boomerang_cb, #b4c_boomerang_select", $dialog)
            .attr("disabled", true)
            .parent().css("color", "#999");
        $("#b4c_boomerang_select", $dialog).replaceWith("<span>(Not available in Preview Pane mode)</span>");
        }

    if(get_gmail_language() === "Other"){
        var disabledOptions = $(".add-event-options");
        disabledOptions.css("color", "grey");
        disabledOptions.attr("title", "This option is only available in English Gmail");
        $("input,select", disabledOptions).attr("disabled", true);
    }

        $("#b4c_reminder_select").change(function()
                {
                        $("#b4c_reminder_cb").prop("checked", true);
                });

        $("#b4c_boomerang_select").change(function()
                {
                        $("#b4c_boomerang_cb").prop("checked", true);
                });

        $("#b4c_select_calendar").html("<option value='primary'>" + get_gmail_user() + "</option>");

    set_up_add_event_ui();

    var url = "https://boomerangcalendar.baydin.com/getcalendars?guser=" + get_gmail_user();
    send_get_request_auth_wrapper(url, callback_to_insert_calendar_selection);

    attach_add_event_dialog_analytics($dialog, source_page_name);

    return $dialog;
}

function set_up_add_event_ui(){
    $("#b4c_event_title").focus();

    $('#b4c_google_invite_cb,#b4c_reminder_cb').click(function(){
        $("#b4c_attendee_emails").show();
        // but if both are unchecked, hide and reset
        var checkedBoxes = $('#b4c_google_invite_cb,#b4c_reminder_cb').filter(function(){
            return $(this).attr("checked");
        });
        if (checkedBoxes.length === 0){
            var defaultAttendees = $("#b4c_default_attendee_emails").html();
            var inputtedAttendees = $("#b4c_inputted_attendee_emails");
            $("#b4c_attendee_emails").hide();
            inputtedAttendees.html(defaultAttendees);
            $("#b4c_add_more_attendees_button").show();
            $("#b4c_more_attendee_emails_input").hide();
        }
    });

    $("#b4c_inputted_attendee_emails").delegate(".b4c_attendee_cancel", "click", function() {
        $(this).closest(".b4c_attendee_display_block").remove();
    });

    $("#b4c_add_more_attendees_button").click(function(){
        $(this).hide();
        $("#b4c_more_attendee_emails_input").show().focus();
    });

    $("#b4c_more_attendee_emails_input").keypress(function(event){
        var keycode = (event.keyCode ? event.keyCode : event.which);
        if(keycode === 13){
            var attendees = $(this).val().toLowerCase().match(EMAIL_REGEX);
            var attendeeHtml = construct_attendee_visual_blocks(attendees);
            $("#b4c_inputted_attendee_emails").html($("#b4c_inputted_attendee_emails").html() + attendeeHtml);
            $(this).val("");
        }
    });

    //setTimeout is necessary so that focus and select don't cancel each other out.
    setTimeout(function() { $('#b4c_event_title').select(); }, 5);

    execute_javascript_on_document(function() {
        var gmaps = new google.maps.places.Autocomplete(document.getElementById("meeting_place_input"));
    });

    function move_autocomplete_to_front(){
        if ($(".pac-container").length > 0){
            $(".pac-container").css("z-index", 999999);
        }
        else{
            setTimeout(move_autocomplete_to_front, 1000);
        }
    }
    move_autocomplete_to_front();
}

function construct_attendee_visual_blocks(attendees){
    var attendeeHtml = "";
    for (var i=0; attendees != null && i<attendees.length; i++) {
        attendeeHtml += "<span class='b4c_attendee_display_block'>" +
            "<span class='by-icon by-icon-peep'></span> " +
            "<span class='b4c_attendee_email'>" + attendees[i] + "</span> " +
            "<span><a class='b4c_attendee_cancel by-icon by-icon-closethick' href='#'>x</a></span>" +
        "</span>";
    }
    return attendeeHtml;
}


function add_event(dialog)
{
    $(".by-error").removeClass("by-error");

    var startTimeInput = $("#start_time_input", dialog).val();
    var startDateInput = $("#start_date_input", dialog).val();

    var startDateTime = Date.parse(startDateInput + " " + startTimeInput);

    if (Date.parse(startTimeInput) == null) {
        $('.by-error-message').text("Not a valid time format.").show();
        $('#start_time_input').addClass("by-error").focus();
        return false;
    }

    if (Date.parse(startDateInput) == null) {
        $('.by-error-message').text("Not a valid date format.").show();
        $('#start_date_input').addClass("by-error").focus();
        return false;
    }

    var endTimeInput = $("#end_time_input", dialog).val();
    var endDateInput = $("#end_date_input", dialog).val();
    var endDateTime = Date.parse(endDateInput + " " + endTimeInput);

    if (Date.parse(endTimeInput) == null) {
        $('.by-error-message').text("Not a valid time format.").show();
        $('#end_time_input').addClass("by-error").focus();
        return false;
    }

    if (Date.parse(endDateInput) == null) {
        $('.by-error-message').text("Not a valid date format.").show();
        $('#end_date_input').addClass("by-error").focus();
        return false;
    }


    var calendarId = $("#b4c_select_calendar", dialog).val();

    var emailDateInput = $("#b4c_email_date", dialog).val();
    var emailDate = "none";
    if(emailDateInput && get_gmail_language() !== "Other"){
        emailDate = Date.parse(emailDateInput);
    }

    var title = $("#b4c_event_title").val();
    var description = $("#meeting_note_input", dialog).val();
    var location = $("#meeting_place_input", dialog).val();

    var timeZone = $("#b4c_timezone", dialog).val();
    var timeZoneOffset = b4c_time_zone_to_offset(timeZone, startDateTime);

    startDateTime.setTimezoneOffset(timeZoneOffset);
    endDateTime.setTimezoneOffset(timeZoneOffset);

    var threadId = $("#b4c_thread_id", dialog).val();
    var attendeeString = construct_attendee_string_for_url();

    var url = "https://boomerangcalendar.baydin.com/insertevent?guser=" + get_gmail_user() +
            "&title=" + encodeURIComponent(title) + "&location=" + encodeURIComponent(location) +
            "&threadId=" + encodeURIComponent(threadId) + "&emailDate=" + emailDate.valueOf() +
            "&startDate=" + startDateTime.valueOf() + "&endDate=" + endDateTime.valueOf() +
            "&calendarId=" + calendarId +
            "&attendees=" + encodeURIComponent(attendeeString);
    if ($("#b4c_boomerang_cb").attr("checked")){
        var boomerangSelected = $("#b4c_boomerang_select").val();
        var boomerangTime;
        switch (boomerangSelected) {
        case "2 hrs before":
            boomerangTime = startDateTime.clone().addHours(-2);
            break;
        case "4 hrs before":
            boomerangTime = startDateTime.clone().addHours(-4);
            break;
        case "day of":
            boomerangTime = startDateTime.clone().clearTime().addHours(6);
            boomerangTime.addMinutes(Math.floor(Math.random() * 30) - 15);
            break;
        case "a day before":
            boomerangTime = startDateTime.clone().addDays(-1);
            break;
        case "a week before":
            boomerangTime = startDateTime.clone().clearTime().addWeeks(-1);
            break;
        case "a month before":
            boomerangTime = startDateTime.clone().clearTime().addMonths(-1);
            break;
        default:
            boomerangTime = startDateTime.clone().addDays(-1);
            break;
        }
        url += "&boomerangTime=" + boomerangTime.valueOf();
    }
    if($("#b4c_reminder_cb").attr("checked")){
        var reminderSelected = $("#b4c_reminder_select").val();
        var recipientReminderTime;
        switch (reminderSelected) {
        case "2 hrs before":
            recipientReminderTime = startDateTime.clone().addHours(-2);
            break;
        case "4 hrs before":
            recipientReminderTime = startDateTime.clone().addHours(-4);
            break;
        case "day of":
            recipientReminderTime = startDateTime.clone().clearTime().addHours(6);
            recipientReminderTime.addMinutes(Math.floor(Math.random() * 30) - 15);
            break;
        case "a day before":
            recipientReminderTime = startDateTime.clone().addDays(-1);
            break;
        case "a week before":
            recipientReminderTime = startDateTime.clone().clearTime().addWeeks(-1);
            break;
        case "a month before":
            recipientReminderTime = startDateTime.clone().clearTime().addMonths(-1);
            break;
        default:
            recipientReminderTime = startDateTime.clone().addDays(-1);
            break;
        }

        url += "&recipientReminderTime=" + recipientReminderTime.valueOf();
    }

    if($("#b4c_google_invite_cb").attr("checked")){
        url += "&googleInvite=True";
        url += "&description=" + encodeURIComponent(description);
    }
    else{
        url += "&googleInvite=False";
        url += "&description=" + encodeURIComponent("Original Email: " + String(document.location) + "\n\n" + description);
    }

    if (endDateTime >= startDateTime) {
        var tentativeEventSets = get_cached_tentative_events(startDateTime, endDateTime, false);
        if( tentativeEventSets.length > 0) {
            show_tentative_events_removal_dialog(tentativeEventSets);
        }
        send_get_request_auth_wrapper(url,insert_event_callback);
        dialog.dialog("destroy");
        return true;
    }
    else {
        $(".by-error").removeClass("by-error");
        $('.by-error-message').text("Start time needs to be earlier than end time.").show();

        if(startDateTime.toString("MMM d yy") === endDateTime.toString("MMM d yy")){
            $('#start_time_input').addClass("by-error").focus();
        }
        else if (Date.parse(startDateTime.toString("MMM d yy")) > Date.parse(endDateTime.toString("MMM d yy"))) {
            $('#start_date_input').addClass("by-error").focus();
        }
        return false;

    }

    function insert_event_callback(data)
    {
        data = JSON.parse(data);

        if (data["status"] === "error"){
            show_dialog(data["details"]);
        }
        else{
            var eventCount = data["eventCount"];
            if (eventCount === ADD_EVENT_COUNT_FOR_VIRAL_HOOK) {

                display_gmail_notification("'" + title + "' was added to your calendar on " + startDateTime.toString(B4C_DISPLAY_PROPOSE_DATE_FORMAT) +".");

                var message = "<p class='bcal_share_header'>Did you know <strong>you just scheduled your " + eventCount +"th meeting </strong> with Boomerang Calendar?</p>";
                    message +="<p>Know anyone who could use Boomerang Calendar? We'd really appreciate it if you share it with your friends.</p>";
                    message += "<div class='bcal_share'><a href='" + generate_tweet_link(ADD_EVENT_VIRAL_HOOK_TEXT) + "' class='bcal_share_button'><img src='" + get_bcal_twitter_icon_url() + "' alt='Share on Twitter'/></a><a href='https://www.facebook.com/dialog/feed?app_id=385824578155763&link=https://boomerangcalendar.com&picture=https://boomerangcalendar.com/img/successful_meetings.jpg&name=Try%20out%20Boomerang%20Calendar&caption=Awesome%20plugin%20for%20Gmail&description=With%20Boomerang%20Calendar%2C%20I%20just%20added%20my%2070th%20meeting%20w%2Fo%20leaving%20my%20inbox.&redirect_uri=https://boomerangcalendar.com' class='bcal_share_button'><img src='" + get_bcal_facebook_icon_url() + "' alt='Share on Facebook'/></a>";
                    message += "<a href='https://plus.google.com/share?url=http%3A%2F%2Fboomerangcalendar.com'onclick='javascript:window.open(this.href, '', 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=600,width=600');return false;'' class='bcal_share_button'><img src='" + get_bcal_gplus_icon_url() + "' alt='Share on Google Plus'/></a></div>";

                setTimeout(function() { show_viral_dialog(message); }, 5000);
            } else {
                display_gmail_notification("'" + title + "' was added to your calendar on " + startDateTime.toString(B4C_DISPLAY_PROPOSE_DATE_FORMAT) +".");
            }
            update_local_event_cache(function(){});
        }
    }

}

function display_create_event_dialog(){
    $(".bcal_dialogdiv").remove();

    var $dialog = init_add_event_dialog("toprow-button-from-existing-thread");
    fill_out_create_event_form($dialog);

    $('.b4c-button-confirm', $dialog).click(function () {
        add_event($(this).parentsUntil(".bcal_dialogdiv").parent());
        $dialog.trigger("event-added");
    });

    $('.b4c-button-cancel', $dialog).click(function () {
        $dialog.trigger("create-event-canceled");
        $(".bcal_dialogdiv").remove();
    });

    $dialog.dialog("open");
}

function show_tentative_events_removal_dialog(tentativeEventSets){
    var frameDoc = get_frame();
    $(".bcal_dialogdiv").remove();
    var message = "<div><h3>Did you just confirm the event below?</h3>" +
        "<p>If so, we can free the other timeslots you reserved for this event.</p>";

    if(tentativeEventSets.length > 1) {
            message = "<div><h3>Did you just confirm any of the events below?</h3>" +
    "<p>If so, we can free the other timeslots you reserved for those events.</p>" +
    "<p>Which of these would you like to free up?</p>";
    }


    for (var i=0; i < tentativeEventSets.length; i++){
        message += "<input type='checkbox' value='" + tentativeEventSets[i][0]['tentativeSetId'] + "' class='b4c_remove_tentatives_cb'> " + remove_notation_from_tentative_event(tentativeEventSets[i][0]['title']) + "</input><br/>";
    }
    var dialog = "<div class='bcal_dialogdiv' style='display:none;'>"+ message+"</div>";
    $("body", frameDoc).append($(dialog));

    $(".bcal_dialogdiv",frameDoc).dialog({
        title: 'Boomerang Calendar',
        width: 500,
        minHeight: 350,
        modal: true,
        resizable: false,
        buttons: {
            "Free Reserved Time Slots": function() {
                remove_tentative_events();
                $(this).dialog("close");
                },
            "Ignore": function() {
                $(this).dialog("close");
                }
        },
    });

    if(tentativeEventSets.length === 1) {
        $('.b4c_remove_tentatives_cb').attr("checked", true);
    }

    function remove_tentative_events(){
        var tentativeIdsArray = $(".b4c_remove_tentatives_cb:checked").map(function(){ return $(this).val(); });
        var tentativeIdsString = $.makeArray(tentativeIdsArray).reduce(function(a,b){ return a + "," + b; });
        var url = "https://boomerangcalendar.baydin.com/deletetentativeevents?guser=" + get_gmail_user() +
                "&ids=" + tentativeIdsString;
        send_get_request_auth_wrapper(url, function callback_to_tentative_event_removal(data) {
            display_gmail_notification("Calendar cleanup completed! :^D ");

            //generate a random number between 1 and 10 and if it's 7, ask them to share.
            if(Math.floor((Math.random()*10)+1) === 7)
            {
                var message = "<p class='bcal_share_header'>Hey! Boomerang Calendar just prevented you from double booking yourself.</p><p>Know anyone who could use Boomerang Calendar? We'd really appreciate it if you share it with your friends.</p>";

                message += "<div class='bcal_share'><a href='" + generate_tweet_link(DELETE_TENTATIVE_EVENT_VIRAL_HOOK_TEXT) + "' class='bcal_share_button'><img src='" + get_bcal_twitter_icon_url() + "' alt='Share on Twitter'/></a>";
                message +="<a href='https://www.facebook.com/dialog/feed?app_id=385824578155763&link=https://boomerangcalendar.com&picture=https://boomerangcalendar.com/img/successful_meetings.jpg&name=Try%20out%20Boomerang%20Calendar&caption=Awesome%20plugin%20for%20Gmail&description="+encodeURIComponent(DELETE_TENTATIVE_EVENT_VIRAL_HOOK_TEXT) + "&redirect_uri=https://boomerangcalendar.com' class='bcal_share_button'><img src='" + get_bcal_facebook_icon_url() + "' alt='Share on Facebook'/></a>";
                message += "<a href='https://plus.google.com/share?url=http%3A%2F%2Fboomerangcalendar.com'onclick='javascript:window.open(this.href, '', 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=600,width=600');return false;'' class='bcal_share_button'><img src='" + get_bcal_gplus_icon_url() + "' alt='Share on Google Plus'/></a></div>";

                setTimeout(function() { show_viral_dialog(message); }, 5000);

            }
            update_local_event_cache(function(){});
        });
    }
}

function remove_notation_from_tentative_event(event_title)
{
    return event_title.slice(4);
}

function construct_attendee_string_for_url(){

    var attendeeArray = [];
    var reminderBoxesChecked = $("#b4c_reminder_cb,#b4c_google_invite_cb").filter(function(){ return $(this).attr("checked"); });
    if (reminderBoxesChecked.length > 0){
        var attendees = $("#b4c_more_attendee_emails_input").val().toLowerCase().match(EMAIL_REGEX);
        for (var i=0; attendees != null && i<attendees.length; i++){
            attendeeArray.push(attendees[i]);
        }
    }

    attendeeArray = attendeeArray.concat(
        $("#b4c_inputted_attendee_emails .b4c_attendee_email")
            .map(function() { return $(this).text(); })
            .toArray()
    );
    attendeeArray = eliminateDuplicatesAndNull(attendeeArray);

    var attendeeString = "";
    for (var i=0; i<attendeeArray.length; i++){
        if (i > 0){
            attendeeString += ", ";
        }
        attendeeString += attendeeArray[i];
    }

    return attendeeString;
}

function show_custom_date_format_dialog_if_necessary_and_continue(what_to_do_next){
    var url = "https://boomerangcalendar.baydin.com/getsuggestedtimescount?guser=" + get_gmail_user();
    send_get_request_auth_wrapper(url, function(data){
        if (data > 0){
            what_to_do_next();
        }
        else{
            display_custom_date_time_format_dialog(what_to_do_next);
        }
    });
}

function open_add_event_window(eventTime, clickedBcalEvent){
    $(".b4c_add_event").parent().remove();
    $(".addEventContainer").hide();

    var startTime = eventTime["startTime"];
    var endTime = eventTime["endTime"];
    var emailDate = eventTime["emailDate"];

    var $dialog = init_add_event_dialog("from-viewcalendar-page");
        fill_out_add_event_form($dialog, eventTime, clickedBcalEvent);

    $dialog.dialog("option", "title", "Add this to calendar");

    $('.b4c-button-confirm', $dialog).click(function(){
        $dialog.trigger("event-added");
        if(add_event($(".addEventContainer"))) {
            // save the user an extra click and close the parent too
            $dialog.parent().parent().dialog('destroy').remove();
        }
    });
    $('.b4c-button-cancel', $dialog).click(function(){
        $(".addEventContainer").hide();
        $dialog.hide().dialog("destroy");
    });

    $('.addEventContainer').show();
    $(".addDetectedEvent").removeClass("by-state-selected");

    var eventID = startTime.toString('MMMdhmmtt') + "_addEvent";
    $("#" + eventID).addClass("by-state-selected");

    $('#boomerang-calendar-display').fullCalendar('gotoDate', startTime);
    highlight_selected_event(startTime.toString('MMMdhmmtt'));

    $dialog.appendTo($('.addEventContainer')).show();
}


//truncate event tile
function truncate_event_title(title){

        return title;
}




function highlight_selected_event(eventID){
        var boom_calendar= $('#boomerang-calendar-display');
        var unselected_events = boom_calendar.fullCalendar('clientEvents', function (event) {
                return (event.id !== eventID) && (event.className.indexOf("detectedTime") >= 0 || event.className.indexOf("alternateTime") >= 0 );
        });
        for (var i=0; i< unselected_events.length ; i ++){
                var event = unselected_events[i];
                event.className = "alternateTime";
                boom_calendar.fullCalendar('updateEvent', event);
        }

        var selected_events = boom_calendar.fullCalendar('clientEvents', eventID);

        for (var i=0; i< selected_events.length ; i ++){
                var event = selected_events[i];
                event.className = "detectedTime";
                boom_calendar.fullCalendar('updateEvent', event);
        }
}

function get_future_events_within_2_weeks($dialog) {
    var MIN_MEETING_TIME = 4 * 60 * 60 * 1000; // 4 hours
    var MAX_MEETING_TIME = 14 * 24 * 60 * 60 * 1000; // 14 Days

    function event_is_between_min_and_max_time(event){
        var timeUntil = { start: event.start - $.now(), end: event.end - $.now() };
        return MIN_MEETING_TIME < timeUntil.start && timeUntil.start < MAX_MEETING_TIME ||
            MIN_MEETING_TIME < timeUntil.end && timeUntil.end < MAX_MEETING_TIME;
    }

    return $("#b4c-calendar-display", $dialog).fullCalendar("clientEvents", event_is_between_min_and_max_time);
}

function get_selected_venue_types($dialog) {
    var types = {};

    $("input:checked[name=meeting-option]", $dialog).each(function(){
        var checkedValue = $(this).val();
        types[checkedValue] = true;
    });

    return types;
}

function get_randomizer_info($dialog) {
    var locInfo = $(".b4c-meeting-location", $dialog).data("location-info") || {};
    var proposalCount = $(".b4c-proposed-times > .b4c-proposed-time", $dialog).length;

    var userLocationInput = $(".b4c-meeting-location", $dialog).val();
    if (locInfo.city != userLocationInput){
        locInfo.city = userLocationInput;
        locInfo.lat = null;
        locInfo.lng = null;
    }

    var options = {
        city: userLocationInput,
        lat: locInfo.lat,
        lng: locInfo.lng,
        timesNeeded: proposalCount || 1
    };

    $.extend(options, get_selected_venue_types($dialog));

    return { options: options, scheduledEvents: get_future_events_within_2_weeks($dialog) };
}

function display_suggest_times_dialog(composeContainer){
    var num_days_in_event_range = function(events) {
        // assuming events are ordered
        if (events.length < 2) {
            return 1;
        }

        return days_between(
            events[0].start,
            events[events.length - 1].end
        ) + 1;
    };
    var adjust_visualcalendar_option_after_eventchange = function($dialog) {
        // visual calendar only supports ranges of 7 days or less
        var $calendar = $("#b4c-calendar-display", $dialog);
        var proposed_events = get_suggested_events_from_calendar($calendar);
        if (proposed_events.length === 0) { return ""; }

        proposed_events = sort_full_calendar_events(proposed_events);
        var $visualcalendar_div = $('.visualcalendar-block', $dialog);
        var visualcalendar_visible = $visualcalendar_div.is(':visible');
        if (visualcalendar_visible && num_days_in_event_range(proposed_events) > 7) {
            $visualcalendar_div.hide();
            $('#b4c-use-visualcalendar-cb', $dialog).prop('checked', false);
        } else if (!visualcalendar_visible && num_days_in_event_range(proposed_events) <= 7) {
            $visualcalendar_div.show();
            $('#b4c-use-visualcalendar-cb', $dialog).prop('checked', true);
        }
    }

    $(".suggestedTimesWidget").dialog("destroy");

    var preferences = get_preferences();

    var $dialog = $(by.template.suggestMeeting.dialog);
    $dialog.dialog({
            title: 'Boomerang Calendar - Suggest Times to Meet',
            width: Math.min(1050, $(window).width()),
            height: Math.min(650, $(window).height()),
            modal: true,
            resizable: true,
            autoOpen: false,
            position: ['center','top'],
            open: function() {
                $(this).data("when-opened", $.now());
                track_event("suggest-time-dialog", "open");
            },
            close: function() {
                $(this).remove();
                hide_autocomplete_click_entry();
                track_event("suggest-time-dialog", "close");
            }
        })
    ;

    $dialog.data("compose-container", composeContainer);

    $dialog
        .bind("dialogresizestop", function() {
            var $calendar = $("#b4c-calendar-display", $dialog);
            var contentHeight = $(".b4c-calendar-container", $dialog).height() -
                $(".fc-header", $calendar).height() - 20; // minus 20 compensate for margins

            $calendar.fullCalendar("option", "contentHeight", contentHeight);
        })
    ;

    var markTentativeCheckbox = $dialog.find("#b4c-mark-tentative");
    markTentativeCheckbox.change(function(){
        var isChecked = $(this).is(":checked");
        var meetingTitle = $("#b4c-meeting-title", $dialog);
        if (isChecked){
            meetingTitle.attr("placeholder", "Meeting Title")
            if (meetingTitle.val() == ""){
                meetingTitle.val("Meeting");
            }
        }
        else{
           meetingTitle.attr("placeholder", "Meeting Title (optional)");
        }
        write_to_localStorage("bcal-mark-tentative-", isChecked);
    })
    if (read_from_localStorage("bcal-mark-tentative-") === 'true'){
        markTentativeCheckbox.attr('checked','checked');
        markTentativeCheckbox.change();
    }


    $dialog
        .bind("generate-meeting", function generate_meeting_listener() {
            var $proposalHolder = $(".b4c-proposed-times", $dialog);
            var proposalCount = $proposalHolder.children().length;

            var info = get_randomizer_info($dialog);
            by.randomizer.fetch_venue(info.options, info.scheduledEvents, function fetch_location_cb(err, location) {
                if(err) {
                    var userLocationInput = $(".b4c-meeting-location", $dialog).val();
                    if(!string_is_whitespace(userLocationInput)){
                        alert("We couldn't find a venue for your meeting. You will have to figure it out on your own.");
                    }
                    throw err.type;
                    } // TODO: log error

                $(".b4c-location-text", $dialog).text(location.name).attr("href", location.url)
                ;
            });

            var ranges = by.randomizer.pickAvailableTimes(info.options, info.scheduledEvents);
            if(!ranges) { // TODO: log error
                alert("We couldn't find a time for your meeting. You will have to figure it out on your own.");
                throw "no-times-available";
            }

            ranges.sort(function(a, b) { return a.start - b.start; });

            ranges.forEach(function(range, idx) {
                if(proposalCount <= idx) { $proposalHolder.trigger("b4c-add-event", [ range ]); }
                else { $proposalHolder.trigger("b4c-update-event", [ range, idx ]); }
            });
        })
    ;

    //unusual Chrome link bug
    if (typeof b4c_is_chrome == "boolean" && b4c_is_chrome){
        $dialog.find(".b4c-location-text").click(function(){
                var link = $(this).attr("href");
                if (link.indexOf("javascript") === -1){
                    window.open(link, '_blank');
                } 
            });
    }

    var cachedMeetingLength = read_from_localStorage("bcal-meeting-length-");
    if (cachedMeetingLength == null){
        if (preferences["defaultMeetingTime"] == 30){
            $("#b4c-30min", $dialog).attr("checked", "checked");
        } else if (preferences["defaultMeetingTime"] == 60){
            $("#b4c-1hour", $dialog).attr("checked", "checked");
        }
    }
    else{
        $('input[name=meeting-length][value="' + cachedMeetingLength + '"]', $dialog).attr("checked", "checked");
    }

    $dialog
        .find("button").button().end()
        .find(".b4c-meeting-length input").button().end()
        .find(".b4c-meeting-options input").button().end()
        .find("#b4c-include-freebusy-cb")
            .prop("checked", function() {
                if (read_from_localStorage("bcal-include-freebusy-") === 'true' ||
                    read_from_localStorage("bcal-include-freebusy-") === null) {
                    return true;
                }
                return false;
            })
        .end()
        .find("#b4c-use-visualcalendar-cb")
            .prop("checked", function() {
                if (read_from_localStorage("bcal-use-visualcalendar-") === 'true' ||
                    read_from_localStorage("bcal-use-visualcalendar-") === null) {
                    return true;
                }

                $("#b4c-include-freebusy-label, #b4c-include-freebusy-help").hide();
                $("#b4c-include-freebusy-cb").prop("checked", false);
                return false;
            })
    ;

    $dialog
        .find("#b4c-go-to-generate-meeting").click(function(e) {
            e.preventDefault();
            if (!$dialog.hasClass("b4c-meeting-in-a-box")){
                track_event("suggest-time-dialog", "generate-automatically", "toggle", "on");
                var $calendar = $("#b4c-calendar-display");
                $calendar.fullCalendar('removeEvents', function(event){
                    return(event.className[0] === "suggestedSlot")
                });
                refresh_calendar_proposed_text($calendar);
                $dialog.addClass("b4c-meeting-in-a-box").trigger("dialogresizestop");
                by.randomizer.get_city_from_browser(function(err, info) {
                    if(err) {
                    } // TODO: Move to be recorded in google analytics
                    else{
                        $(".b4c-meeting-location", $dialog).val(info.city).data("location-info", info);
                        $dialog.trigger("generate-meeting");
                    }
                });
                $(".b4c-locationSuggestions", $dialog).hide();
                $(".b4c-meeting-length-title", $dialog).hide();
                $(".b4c-meeting-length", $dialog).hide();
                $(this).addClass("b4c-toggled-button");
                $(this).attr("title", "Go back to regular view");
            }
            else{
                track_event("suggest-time-dialog", "generate-automatically", "toggle", "off");
                $dialog.removeClass("b4c-meeting-in-a-box").trigger("dialogresizestop");
                $("#b4c-go-to-generate-meeting", $dialog).show();
                $(".b4c-meeting-length-title", $dialog).show();
                $(".b4c-meeting-length", $dialog).show();
                $(this).removeClass("b4c-toggled-button");
                $(this).attr("title", "Feeling lucky? Let Boomerang generate an ideal meeting time for you.");
            }
        });


    $dialog
        .find(".b4c-randomize-meeting").click(function(e) {
            track_event("suggest-time-dialog", "try-again-automatically", "click");
            e.preventDefault();
            $dialog.trigger("generate-meeting");
        })
    ;

    $dialog
        .find(".b4c-meeting-location").change(function() { $(this).removeData("location-info"); })
    ;

    $dialog
        .find(".b4c-insert-content").click(function(e) {
            e.preventDefault();
            track_event("suggest-time-dialog", "insert-into-email", "click");
            var suggestions = get_suggested_events_from_calendar($("#b4c-calendar-display", $dialog));
            if (suggestions.length == 0){
                $dialog.find(".b4c-suggest-error.by-error-message")
                    .text("Please select at least one time slot.").show()
                    .end()
                return;
            }

            track_event("suggest-time-dialog", "potentialmeeting-count-on-insert", 'count', suggestions.length);

            var location_used = get_meeting_location().length > 0;
            track_event("suggest-time-dialog", "did-suggestion-use-location-on-insert", 'count', Number(location_used));
            var used_visualcaelndar = $("#b4c-use-visualcalendar-cb", $dialog).attr('checked');
            track_event("suggest-time-dialog", "did-use-visualcalendar", (used_visualcaelndar ? 'yes' : 'no'));
            if (used_visualcaelndar) {
                track_event("suggest-time-dialog", "did-show-freebusy",
                    ($("#b4c-include-freebusy-cb", $dialog).attr('checked') ? 'yes' : 'no'));
            }

            generate_email_template_from_suggest_times_dialog($dialog);
        })
    ;

    $dialog
        .find(".b4c-reroll-venue").click(function reroll_venue_click(e) {
            track_event("suggest-time-dialog", "reroll-place", "click");
            e.preventDefault();

            var info = get_randomizer_info($dialog);
            by.randomizer.fetch_venue(info.options, info.scheduledEvents, function reroll_venue(err, location) {
                if(err) { // TODO: log error
                    alert("We couldn't find a venue for your meeting. You will have to figure it out on your own.");
                    throw err.type;
                }

                $(".b4c-location-text", $dialog).text(location.name).attr("href", location.url);
            });
        })
    ;

    $dialog
        .find(".b4c-add-time").click(function(e) {
            e.preventDefault();
            track_event("suggest-time-dialog", "add-another-auto-slot", "click");

            if($(".b4c-proposed-times > .b4c-proposed-time", $dialog).length > 5) { return; }

            var info = get_randomizer_info($dialog);
            info.options.timesNeeded = 1;
            var ranges = by.randomizer.pickAvailableTimes(info.options, info.scheduledEvents);

            if(!ranges) { // TODO: log error
                alert("We couldn't find a time for your meeting. You will have to figure it out on your own.");
                throw "no-times-available";
            }

            $(".b4c-proposed-times", $dialog).trigger("b4c-add-event", [ ranges[0] ]);
        })
    ;

    $dialog
        .find(".b4c-button-cancel").click(function(e) {
            e.preventDefault();
            track_event("suggest-time-dialog", "close-on-left", "click");
            $dialog.dialog("close");
        })
    ;

    // set up analytics for click/unclick breakfast/lunch/dinner/etc
    $dialog.find('[type=checkbox][name=meeting-option]').change(function() {
         track_event("suggest-time-dialog", "auto-meetingtype-changed",
             this.id, Number(this.checked));
    });


    $dialog
        .find(".b4c-proposed-times")
            .bind("b4c-add-event", function add_new_event_to_calendar_and_proposed_times(e, range) {
                var event = {
                    id: "proposal" + (Math.random() + "").substr(2),
                    title: "Proposed Time",
                    className: "suggestedSlot",
                    start: range.start,
                    end: range.end,
                    allDay: !!range.allDay,
                    b4c_preserve_event_when_syncing: true,
                    // Number is displayed both on the event in full calendar and in the list of proposed times.
                    b4c_proposal_idx: $(".b4c-proposed-times > .b4c-proposed-time", $dialog).length + 1
                };

                var $calendar = $("#b4c-calendar-display", $dialog);
                $calendar.fullCalendar("renderEvent", event, true);
            })
            .bind("b4c-update-event", function update_date_fullcalendar_event(e, range, idx) {
                var $calendar = $("#b4c-calendar-display", $dialog);

                var eventId = $(".b4c-proposed-times > .b4c-proposed-time", $dialog).eq(idx).data("event-id");
                var event = $calendar.fullCalendar("clientEvents", eventId)[0];

                event.start = range.start;
                event.end = range.end;

                $calendar.fullCalendar("updateEvent", event);
            })
            .bind("b4c-add-event b4c-update-event", function batch_updates_to_proposed_times_text(e, range) {
                if($dialog.data("refresh-timer")) { $dialog.data("refresh-times").push(range.start); return; }

                $dialog.data("refresh-times", [ range.start ]);
                var timer = setTimeout(function() { // Ensures refresh_calendar_proposed_text isn't called too often
                    var $calendar = $("#b4c-calendar-display", $dialog);
                    refresh_calendar_proposed_text($calendar);

                    var times = $dialog.data("refresh-times").sort();
                    var middle = times[(times.length / 2) >> 0];
                    $calendar.fullCalendar("gotoDate", middle);

                    $dialog.removeData("refresh-timer").removeData("refresh-times");
                }, 0);

                $dialog.data("refresh-timer", timer);

                $(".b4c-proposed-times", $dialog).trigger("b4c-refresh-event-indexes");
            })
            .bind("b4c-refresh-event-indexes", function() {
                var $calendar = $("#b4c-calendar-display", $dialog);

                var eventToIdx = {};
                $(".b4c-proposed-times .b4c-proposed-time", $dialog).each(function(idx) {
                    var eventId = $(this).data("event-id");

                    $(this).data("proposal-index", idx + 1);
                    eventToIdx[eventId] = $(this).data("proposal-index");
                });

                $(".b4c-event-proposal-idx", $calendar).each(function() {
                    var eventId = $(this).data("event-id");

                    $(this).text(eventToIdx[eventId]);
                });
            })
            // .delegate(".b4c-reroll-time", "click", function(e) {
            //     track_event("suggest-time-dialog", "reroll-time", "click");
            //     e.preventDefault();

            //     var info = get_randomizer_info($dialog);
            //     info.options.timesNeeded = 1;
            //     var ranges = by.randomizer.pickAvailableTimes(info.options, info.scheduledEvents);

            //     if(!ranges) { // TODO: log error
            //         alert("We couldn't find a time for your meeting. You will have to figure it out on your own.");
            //         throw "no-times-available";
            //     }

            //     var $proposedHolder = $(".b4c-proposed-times", $dialog);
            //     var idx = $proposedHolder.children().index($(this).closest(".b4c-proposed-time"));
            //     $proposedHolder.trigger("b4c-update-event", [ ranges[0], idx ]);
            // })
            .delegate(".b4c-time-remove", "click", function(e) {
                e.preventDefault();

                var $time = $(this).closest(".b4c-proposed-time");
                var $calendar = $("#b4c-calendar-display", $dialog);

                $calendar.fullCalendar("removeEvents", $time.data("event-id"));
                refresh_calendar_proposed_text($calendar);
                adjust_visualcalendar_option_after_eventchange($dialog);

                $(".b4c-proposed-times", $dialog).trigger("b4c-refresh-event-indexes");
            })
            .delegate(".b4c-time-goto", "click", function(e) {
                e.preventDefault();
                var $time = $(this).closest(".b4c-proposed-time");
                var $calendar = $("#b4c-calendar-display", $dialog);
                $calendar.fullCalendar('gotoDate', $time.data("date"));
            })
    ;

      $("#b4c-use-visualcalendar-cb", $dialog).change(function() {
          // 'show my availability' option is useless if you aren't using visual calendar
          var $freebusy = $('#b4c-include-freebusy-label, #b4c-include-freebusy-help');
          if (this.checked) {
              $freebusy.show();
          } else {
              $freebusy.hide();
          }

          write_to_localStorage("bcal-use-visualcalendar-", $(this).is(":checked"));
      });

      $("#b4c-include-freebusy-cb", $dialog).change(function() {
          write_to_localStorage("bcal-include-freebusy-", $(this).is(":checked"));
      });


    var init_full_calendar = function($calendar, slotMinutes, events){
        $calendar.fullCalendar("destroy");
        slotMinutes = slotMinutes || 15;
        events = events || get_all_events_from_local_storage();

        $calendar.fullCalendar({
            editable: true,
            disableDragging: true,
            events: events,
            firstHour: 8,
            firstDay: preferences["startOfWeek"],
            allDaySlot: true,
            header: {
                left: '',
                center: 'prev, title, next',
                right:    'today agendaDay,agendaWeek'
            },
            buttonText: {
                prev: '&lt;',
                next: '&gt;'
            },
            contentHeight: 525,
            defaultView: 'agendaWeek',
            defaultEventMinutes: preferences["defaultMeetingTime"],
            titleFormat: {
                month: 'MMMM yyyy',
                week: FULL_CALENDAR_TITLE_WEEK_FORMAT,
                day: FULL_CALENDAR_TITLE_DAY_FORMAT
            },
            columnFormat: {
                week: FULL_CALENDAR_COLUMN_WEEK_FORMAT
            },
            selectable: true,
            selectHelper: true,
            slotMinutes: slotMinutes,
            snapMinutes: slotMinutes,
            eventResize: function(event,dayDelta,minuteDelta,revertFunc, jsEvent, ui, view) {
                refresh_calendar_proposed_text($("#b4c-calendar-display", $dialog));
                $("#b4c-custom-length", $dialog).click();
            },
            eventAfterRender: function(event, elem, view) {
                adjust_visualcalendar_option_after_eventchange($dialog);
            },
            select: function (start, end, allDay) {
                var $proposedTimes = $(".b4c-proposed-times", $dialog);
                // use inputted meeting time if available
                var meetingLength = parseInt($('input:checked[name=meeting-length]').val());
                if (!isNaN(meetingLength) && !allDay){
                    var myStart = start.clone();
                    var myEnd = start.clone().addMinutes(meetingLength);
                    $proposedTimes.trigger("b4c-add-event", [ { start:myStart, end: myEnd, allDay: false } ]);
                    while (myEnd < end){
                        myStart = myStart.clone().addMinutes(meetingLength);
                        myEnd = myEnd.clone().addMinutes(meetingLength);
                        $proposedTimes.trigger("b4c-add-event", [ { start:myStart, end: myEnd, allDay: false } ]);
                    }
                }
                // otherwise use default meeting time
                else{
                    if (end < start.clone().addMinutes(preferences["defaultMeetingTime"])){
                        end = start.clone().addMinutes(preferences["defaultMeetingTime"]);
                    }
                    $proposedTimes.trigger("b4c-add-event", [ { start:start, end: end, allDay: allDay } ]);
                }
                track_event("suggest-time-dialog", "add-event-manually-via-calendar", "click");
                $("#b4c-calendar-display", $dialog).fullCalendar('unselect');
            },
            viewDisplay: function(view) {
                full_calendar_sync_and_render_current_view(view, $("#b4c-calendar-display", $dialog));
            }
        });
        by.timezone.addMenusToCalendar($calendar);

        $calendar
            .bind("primary-agenda-timezone-change secondary-agenda-timezone-change refresh-proposed-times", function() {
                var $calendar = $("#b4c-calendar-display", $dialog);
                refresh_calendar_proposed_text($calendar);
        });
    };


    var slotMinutes = 30;
    if (cachedMeetingLength == 15 || cachedMeetingLength == 45){
        slotMinutes = 15;
    }
    init_full_calendar($("#b4c-calendar-display", $dialog), slotMinutes);


    // meeting length buttons
    $dialog.find('input[name=meeting-length]').click(function() {
        var $this = $(this);
        $dialog.trigger("b4c-adjust-meeting-lengths", $this.val());
        track_event("suggest-time-dialog", "adjust-meeting-length", $this.val());
        write_to_localStorage("bcal-meeting-length-", $(this).val());
    });
    $dialog.bind("b4c-adjust-meeting-lengths", function adjust_meeting_lengths(e, time){
        var minutes = parseInt(time);
        if (!isNaN(minutes)){
            var $calendar = $("#b4c-calendar-display");
            events = get_suggested_events_from_calendar($calendar);
            for (var i in events){
                if (!events[i]["allDay"]){
                    var myStart = events[i]["start"].clone();
                    var myEnd = myStart.clone().addMinutes(minutes);
                    var end = events[i]["end"];
                    if (!myEnd.equals(end)){
                        $calendar.fullCalendar('removeEvents', events[i]["id"]);
                        var $proposedTimes = $(".b4c-proposed-times", $dialog);
                        $proposedTimes.trigger("b4c-add-event", [ { start:myStart, end: myEnd, allDay: false } ]);
                        while (myEnd < end){
                            var $proposedTimes = $(".b4c-proposed-times", $dialog);
                            myStart = myStart.clone().addMinutes(minutes);
                            myEnd = myEnd.clone().addMinutes(minutes);
                            $proposedTimes.trigger("b4c-add-event", [ { start:myStart, end: myEnd, allDay: false } ]);
                        }
                    }
                }
            }
            var slotMinutes = 30;
            if (minutes == 15 || minutes == 45){
                slotMinutes = 15;
            }
            var events = $calendar.fullCalendar("clientEvents");
            init_full_calendar($calendar, slotMinutes, events);
        }
    });


    $('#b4c_default_location,#b4c_place_autocomplete')
        .click(function b4c_default_location_clicked(){
            show_autocomplete_field();

            $(".pac-container").remove();
            execute_javascript_on_document(set_up_google_place_autocomplete);

            $("#b4c_place_autocomplete").keyup(function(event){
                if(event.keyCode === 13){ $("body").click(); }
            });
        })
//        TODO replace with better analytics
//        .click(function() { track_event("suggest-time-dialog", "location-link-clicked"); })
        .show()
    ;

    function show_help_dialog(msg){
        var $helpDialog = $("<div class='bcal_dialogdiv' style='padding:23px 30px 15px 30px;'>" + 
                    msg +
                "</div>"
            );
        $helpDialog.dialog({
                title: 'Boomerang Calendar',
                width: "500",
                height: "auto",
                modal: true,
                resizable: false,
                autoOpen: false,
                position: { my: "center", at: "center", of: $dialog },
                buttons: [
                    {
                        text: "Close",
                        "class": "b4c_close_dialog",
                        click: function() { $helpDialog.dialog("close"); }
                    }
                ]
        });
        $helpDialog.dialog("open");
        return $helpDialog;
    }

    $dialog.find(".by-icon-info")
        .css("cursor", "pointer")
        .click(function(){
            show_help_dialog($(this).attr("bcal-title"));
    });

    set_up_location_suggestion($dialog);

    // The next two lines of code are here to fix perforance issues with fullcalendar.
    // Turns out fullcalendar can't work on in-memory elements but takes over a second
    // to render in firefox when attached to the DOM.    To get around this issue,
    // we render fullcalendar in-memory then force it to refresh by simulating a
    // window resize.

    $dialog.dialog("open");
    setTimeout(function() { $(window).trigger("resize"); }, 0);

    return $dialog;
}

function set_up_location_suggestion($dialog){
    function show_location_suggestion_if_necessary($dialog){
        var autocomplete = $("#b4c_place_autocomplete", $dialog);
        var text = autocomplete.val();
        var $locationSuggestions = $(".b4c-locationSuggestions", $dialog);
        if (autocomplete.is(":visible") && autocomplete.is(":focus") && text.length == 0){
            $locationSuggestions.show();
            $('#b4c_location_type', $dialog).val("place");
            $(document).click(function removeAutocomplete(e){
                if($(e.target).closest(".b4c-locationSuggestions,#b4c_place_autocomplete").length > 0) { return; }
                $locationSuggestions.hide();
                $(document).unbind("click", removeAutocomplete);
            });
        }
        else{
            $locationSuggestions.hide();
        }
    }
    function refresh_location_suggestions($dialog){
        function click_location_suggestion(){
            var $locationSuggestion = $(this).closest(".b4c-suggested-location-history");
            var locationData = $locationSuggestion.data();
            var uid = locationData["uid"];
            update_location_in_local_storage(uid);
            var locationText = locationData["text"];
            var locationHtml = locationData["html"];
            var locationName = locationData["displayText"];
            $("#b4c_place_autocomplete").val(locationText);
            $("#b4c_places_parity").val(locationText);
            $("#b4c_places_field").val(locationHtml);
            $("#b4c_places_name").val(locationName);
            $("#b4c_places_draft_output").text(locationHtml);
            if (locationName.indexOf("Phone") == 0){
                $('#b4c_location_type', $dialog).val("phone");
            }
            else if (locationName.indexOf("Online") == 0){
                $('#b4c_location_type', $dialog).val("online");
            }
            refresh_location_suggestions();
            $("#b4c_place_autocomplete").click(); // not sure why this is needed
            track_event("suggest-time-dialog", "location-history", "click");
        }

        function click_remove_location(clickedLink){
            var $locationSuggestion = $(clickedLink).closest(".b4c-suggested-location-history");
            var locationData = $locationSuggestion.data();
            var uid = locationData["uid"];
            remove_location_from_local_storage(uid);
            $locationSuggestion.remove();
        }

        $(".b4c-suggested-location-history", $dialog).remove();
        var $locationSuggestions = $(".b4c-locationSuggestions > .by-menu-separator", $dialog);
        var sortedLocations = get_sorted_locations_from_local_storage();
        for (var i in sortedLocations){
            var mySuggestion = sortedLocations[i];
            var $suggestion = $(by.template.suggestMeeting.locationSuggestion);
            $suggestion.find(".b4c-suggested-location-text").text(mySuggestion["displayText"]);
            $suggestion.click(click_location_suggestion)
            $suggestion.find(".b4c-suggested-location-remove").click(function(e){
                e.stopPropagation();
                click_remove_location(this)
            });
            $suggestion.data(mySuggestion);
            $locationSuggestions.before($suggestion);
        }
    }
    function show_add_phone_dialog(callback){
        callback = callback || $.noop;
        var $phoneDialog = $("<div class='bcal_dialogdiv' style='margin:20px 0px 0px 15px; padding:0px;'>" +
            "<span style='margin-right: 5px;'>Please call me at: </span>" +
            "<input class='bcal-phone-input' placeholder='Enter phone number' style='width:225px' /></div>");
        $phoneDialog.dialog({
                title: 'Enter your phone number',
                width: 400,
                height: 150,
                modal: true,
                resizable: false,
                autoOpen: false,
                position: { my: "center", at: "center", of: $dialog },
                buttons: [
                    {
                        text: "Save",
                        "class": "by-button-primary",
                        click: function() { 
                            var phone = $phoneDialog.find(".bcal-phone-input").val();
                            callback(phone);
                            $phoneDialog.dialog("close");
                        }
                    },
                    {
                        text: "Cancel",
                        "class": "b4c_close_dialog",
                        click: function() { $phoneDialog.dialog("close"); }
                    }
                ]
        });
        $phoneDialog.dialog("open");
        $(".by-dialog-titlebar-close", $phoneDialog.parent()).hide();
        return $phoneDialog;
    }
    function show_online_meeting_dialog(callback){
        callback = callback || $.noop;
        var $onlineDialog = $("<div class='bcal_dialogdiv' style='margin:20px 0px 0px 15px; padding:0px;'>" + 
                "<span style='margin-right: 5px;'>Please find me on: </span>" +
                "<input class='bcal-online-input' placeholder='e.g. Skype - jonsmith' style='width:225px' /></div>"
            );
        $onlineDialog.dialog({
                title: 'Enter your online meeting details',
                width: 400,
                height: 150,
                modal: true,
                resizable: false,
                autoOpen: false,
                position: { my: "center", at: "center", of: $dialog },
                buttons: [
                    {
                        text: "Save",
                        "class": "by-button-primary",
                        click: function() { 
                            var online = $onlineDialog.find(".bcal-online-input").val();
                            callback(online);
                            $onlineDialog.dialog("close");
                        }
                    },
                    {
                        text: "Cancel",
                        "class": "b4c_close_dialog",
                        click: function() { $onlineDialog.dialog("close"); }
                    }
                ]
        });
        $onlineDialog.dialog("open");
        $(".by-dialog-titlebar-close", $onlineDialog.parent()).hide();
        return $onlineDialog;
    }

    $(".by-location-add-phone", $dialog).click(function(){
        track_event("suggest-time-dialog", "add-phone", "click");
        $(".b4c-locationSuggestions", $dialog).hide();
        show_add_phone_dialog(function afterPhoneEntry(phone){
            add_location_to_local_storage("Phone - " + phone, "phone", "Phone - " + phone);
            refresh_location_suggestions($dialog);
            $("#b4c_place_autocomplete", $dialog).val("Phone - " + phone);
            $('#b4c_location_type', $dialog).val("phone");
            track_event("suggest-time-dialog", "add-phone", "entered");
        });
    });
    $(".by-location-add-online", $dialog).click(function(){
        track_event("suggest-time-dialog", "add-online", "click");
        $(".b4c-locationSuggestions", $dialog).hide();
        show_online_meeting_dialog(function afterOnlineEntry(online){
            add_location_to_local_storage("Online - " + online, "online", online);
            refresh_location_suggestions($dialog);
            $("#b4c_place_autocomplete", $dialog).val(online);
            $('#b4c_location_type', $dialog).val("online");
            track_event("suggest-time-dialog", "add-online", "entered");
        });
    });
    $("#b4c_place_autocomplete", $dialog).keyup(function(){
        show_location_suggestion_if_necessary($dialog);
    });
    $("#b4c_place_autocomplete", $dialog).focus(function(){
        show_location_suggestion_if_necessary($dialog);
    });
    show_location_suggestion_if_necessary($dialog);
    refresh_location_suggestions($dialog);
}


function refresh_calendar_proposed_text($calendar){
    var dateFormat = "ddd MMM d";

    var $proposedContainer = $(".b4c-proposed-times");
    $proposedContainer.empty();
    var myEvents = get_suggested_events_from_calendar($calendar);
    myEvents.sort(function(a, b){return a["start"] - b["start"]})
    var primaryTimeZoneName = $calendar.find(".primary-timezone-header").text();
    var primaryTimeZoneOffset = $calendar.data("fullCalendar").options["primary-agenda-timezone"];
    var secondaryTimeZoneName = $calendar.find(".secondary-timezone-header").text();
    var secondaryTimeZoneOffset = $calendar.data("fullCalendar").options["secondary-agenda-timezone"];
    var processedDatesHash = {};

    for (var i = 0; i < myEvents.length; i++){
        var myEvent = myEvents[i];
        var startDate = myEvent["start"].toString(dateFormat);
        var readableText = convert_event_to_scheduling_string(myEvent, primaryTimeZoneOffset, primaryTimeZoneName,
            secondaryTimeZoneOffset, secondaryTimeZoneName);
        var $proposedTime = $(by.template.suggestMeeting.proposedTime)
            .data("event-id", myEvent.id)
            .data("date", myEvent["start"])
            .data("proposal-index", myEvent.b4c_proposal_idx)
            .find(".b4c-event-time").text(myEvent.title).end()
            .find(".b4c-event-time").html(readableText).end();

        if (processedDatesHash[startDate] == null){
            processedDatesHash[startDate] = "yes";
            $proposedContainer.append("<div class='b4c-proposed-date'>" + startDate + " </div>");
        }
        $proposedContainer.append($proposedTime);
    }


}

// complicated location logic because of Generate a meeting and Google Maps API dance
var get_meeting_location = function() {
    var location = "";

    if ($(".b4c-location-text-container:visible").length > 0){
        location = $("#b4c-location-meeting-draft-output").html();
    } else {
        location = $("#b4c_places_draft_output").text();
    }

    return location;
}

var get_meeting_location_text = function(){
    var location = $("#b4c_places_name").val();
    if (!location){
        if ($(".b4c-location-text-container:visible").length > 0){
            location = $(".b4c-location-text").text();
        }
        else{
            location = $("#b4c_place_autocomplete").val();
        }
    }
    return location;
}

function generate_email_template_from_suggest_times_dialog($dialog) {
    var isMarkAsTentative = $("#b4c-mark-tentative", $dialog).prop("checked");
    var isUseVisualCalendar = $("#b4c-use-visualcalendar-cb", $dialog).prop("checked");
    var show_freebusy = $("#b4c-include-freebusy-cb", $dialog).prop("checked");

    if(isMarkAsTentative && !$('#b4c-meeting-title', $dialog).val()) {
        $(".b4c-meeting-title-container", $dialog)
            .find(".by-error-message")
                .text("Please enter an event title if you wish to reserve the time slots in your calendar.")
                .show()
            .end()
            .find('#b4c-mark-tentative').focus().end()
            .find("#b4c-meeting-title").addClass("by-error")
        ;
        return false;
    }

    var $calendar = $("#b4c-calendar-display", $dialog);
    var suggestEvents = get_suggested_events_from_calendar($calendar);

    if(isMarkAsTentative && suggestEvents.length > 10) {
        $(".b4c-suggest-error.by-error-message", $dialog)
            .text("Please select 10 or fewer reserved time slots.")
            .show()
        ;
        return false;
    }

    hide_autocomplete_click_entry();

    show_custom_date_format_dialog_if_necessary_and_continue(function insert_times_into_draft() {
        send_suggest_times_request();

        if(isMarkAsTentative) { 
            insert_tentative_events($calendar, $('#b4c-meeting-title', $dialog).val(), after_tentative_event_callback); 
        }
        else{
            after_tentative_event_callback("");
        }

        function after_tentative_event_callback(tentativeId){
            var options = {
                location: get_meeting_location(),
                locationText: get_meeting_location_text(),
                sendCalendar: isUseVisualCalendar,
                show_freebusy: show_freebusy,
                tentativeId: tentativeId,
                subject:  $('#b4c-meeting-title', $dialog).val(),
                locationType: $('#b4c_location_type', $dialog).val(),
            };
            var prependedHtmlDraft = generate_prepended_suggest_times_draft($calendar, options);
            var insertedHtmlDraft = generate_inserted_suggest_times_draft($calendar, options);

            var $composeContainer = $dialog.data("compose-container");
            if(!$composeContainer) { // null when reply compose isn't open (ex when user clicks suggest time from BCal thread button)
                open_reply_window();

                $composeContainer = $(".aeJ,.ar4", get_frame()).find(".I5,.fN");
                // For pre-pop-in compose: ".Am.Al:not(:has(iframe))" for HTML compose, plain text is handled later
                // For new pop-in compose: ".LW-avf" for chrome and ".Am.Al > iframe" for firefox
                var $composeTextBody = $(".Am.Al:not(:has(iframe)), .LW-avf, .Am.Al > iframe", $composeContainer);
                $composeTextBody.addClass("b4c-insert-text-here");

                $dialog.data("compose-container", $composeContainer);

                return setTimeout(insert_times_into_draft, 0); // Give browser some time to open the reply.
            }

            $("#b4c_generated_prepended_text").val(prependedHtmlDraft);
            $("#b4c_generated_inserted_text").val(insertedHtmlDraft);

            if($(".b4c-insert-text-here", $composeContainer).length > 0) { // HTML compose window
                execute_javascript_on_document(function() {
                    var textContainer = by.get_frame().getElementsByClassName("b4c-insert-text-here")[0];
                    var range = by.selection.restore(textContainer.contentWindow || window);

                    var bcalMeetingHtml = document.getElementById("b4c_generated_prepended_text").value;
                    var bcalMeetingElt = by.get_frame().createElement("div");
                    bcalMeetingElt.innerHTML = bcalMeetingHtml;

                    var editableElem = textContainer;
                    if(textContainer.contentDocument) { editableElem = textContainer.contentDocument.body; }

                    if(range && editableElem.contains(range.startContainer) && editableElem.contains(range.endContainer)) {
                        range.deleteContents();
                        range.insertNode(bcalMeetingElt);
                    } else {
                        editableElem.insertBefore(bcalMeetingElt, editableElem.firstChild);
                    }
                });
                $(".b4c-insert-text-here").removeClass("b4c-insert-text-here");
            } else { // Plain text compose window
                var editableElem = $(".aXjCH:visible", $composeContainer);
                if(editableElem.length <= 0) { throw Error("Don't know where to insert event text."); }

                var currentText = editableElem.val();
                var eventText = GPTOHWLB25(prependedHtmlDraft);
                editableElem.val(eventText + "\n\n" + currentText);
            }

            $dialog.dialog("close");
        }
    });
}

function show_autocomplete_field(){
    var defaultLocation = $('#b4c_default_location');
    var autocomplete = $("#b4c_place_autocomplete");
    defaultLocation.hide();
    autocomplete.show();
    autocomplete.focus();
}
function hide_autocomplete_click_entry(){
    var defaultLocation = $('#b4c_default_location');
    var autocomplete = $("#b4c_place_autocomplete");
    var inputted_location_text = autocomplete.val();
    var places_field_text = $("#b4c_places_field").val();
    var places_parity_text = $("#b4c_places_parity").val();

    var places_output = $("#b4c_places_draft_output");

    // logic to interact with Google Places output
    if (!string_is_whitespace(inputted_location_text)){
        if (places_parity_text === inputted_location_text){
            places_output.text(places_field_text);
        }
        else{
            places_output.text(inputted_location_text);
        }
        defaultLocation.text(inputted_location_text);
    }
    else{
        defaultLocation.text("");
        places_output.text("");
    }
    defaultLocation.show();
}


// This is called inside Gmail itself.
// Therefore, we CANNOT use Jquery
function set_up_google_place_autocomplete()
{
    var googleAutocompleteObject = new google.maps.places.Autocomplete(document.getElementById('b4c_place_autocomplete'));
    google.maps.event.addListener(googleAutocompleteObject, 'place_changed', function() {
        var place = googleAutocompleteObject.getPlace();
        var address = place.formatted_address;
        if (address) {
            address = address.replace(/,\s*(united\s*states$|usa?)\s*$/i, "");
            var types = place.types;
            var placeField = "";
            var isStreetAddress = false;
            for (var i=0; i<types.length; i++){
                if (types[i] === "street_address"){
                    isStreetAddress = true;
                }
            }
            if (isStreetAddress){
                var url = "http://maps.google.com/?q=" + address;
                placeField = "<a href ='" + url + "'>" + address + "</a>";
                document.getElementById("b4c_places_name").value = address;
            }
            else{
                var name = place.name;
                var url = place.url;
                placeField = "<a href ='" + url + "'>" + name + "</a> (" + address +")";
                document.getElementById("b4c_places_name").value = name;
            }
            document.getElementById("b4c_places_field").value = placeField;
            document.getElementById("b4c_places_parity").value = document.getElementById("b4c_place_autocomplete").value;
        }
    });
}

function get_suggested_events_from_calendar($calendar){
    return $calendar.fullCalendar("clientEvents", function(event){
        return(event.className[0] === "suggestedSlot");
    });
}

function get_detected_events_from_calendar($calendar){
    return $calendar.fullCalendar("clientEvents", function(event){
        return(event.className[0] === "detectedTime" || event.className[0] === "alternateTime");
    });
}

function generate_inserted_suggest_times_draft($calendar, options) {
    return generate_suggest_time_draft($calendar, options, true);
}

function generate_prepended_suggest_times_draft($calendar, options) {
    return generate_suggest_time_draft($calendar, options, false);
}

function generate_suggest_time_draft($calendar, options, shouldBeInsertedIntoDraft) {
    var suggestedEventTimes = get_suggested_events_from_calendar($calendar);
    var location = options.location;
    var locationText = options.locationText;
    var locationType = options.locationType || "place";
    if (suggestedEventTimes.length === 0) { return ""; }

    sort_full_calendar_events(suggestedEventTimes);

    if (string_is_whitespace(location)){
        location = "";
    }

    location = (location || "").trim();

    var primaryTimeZoneName = $calendar.find(".primary-timezone-header").text();
    var primaryTimeZoneOffset = $calendar.data("fullCalendar").options["primary-agenda-timezone"];
    var secondaryTimeZoneName = $calendar.find(".secondary-timezone-header").text();
    var secondaryTimeZoneOffset = $calendar.data("fullCalendar").options["secondary-agenda-timezone"];

    var draftHtml = "<div>";
    if (suggestedEventTimes.length === 1) {
        draftHtml += "Can we meet on ";
        draftHtml += convert_event_to_suggestion_string(suggestedEventTimes[0], primaryTimeZoneOffset, primaryTimeZoneName, secondaryTimeZoneOffset, secondaryTimeZoneName);
        if(location) { 
            draftHtml += "?" ;
            if (locationType == "place"){
                draftHtml += " We can meet at " + location; 
            }
            else if(locationType == "phone"){
                draftHtml += " Please call me at: " + location.replace("Phone - ", "");
            }
            else{
                draftHtml += " Please find me on: " + location;
            }
            draftHtml += ".<br/>";
        }
        else{
            draftHtml += "?<br/>";
        }
    }
    else {
        if (!shouldBeInsertedIntoDraft){
            if (options.sendCalendar){
                draftHtml += "Please click a time that works for you in the calendar image below to confirm. Calendar invitations will be sent to both of us. If you don't see the calendar, make sure your mail client is set to display images.<br/>";
            }
            else{
                draftHtml += "Do any of the times below work for you?<br/>";
            }
        }

        if (location) { 
            draftHtml += "<br/><div>"; 
            if (locationType == "place"){
                draftHtml += " We can meet at " + location; 
            }
            else if(locationType == "phone"){
                draftHtml += " Please call me at: " + location.replace("Phone - ", "");
            }
            else{
                draftHtml += " Please find me on: " + location;
            }
            draftHtml += ".</div>"; }
    }

    if (options.sendCalendar) {
        draftHtml += window.by.availability_map.get_availability_html({
            proposed_times: suggestedEventTimes,
            include_clickable_times: false,
            weekdays_to_skip: '',  // when suggesting times, showing weekend is OK
            show_freebusy: options.show_freebusy,
            tentativeId: options.tentativeId,
            location: locationText,
            subject: options.subject,
            // TODO: maybe separate freebusy and 'where can you click'
        });
    } 

    if (suggestedEventTimes.length > 1){
        if (options.sendCalendar){
            draftHtml += "Here are the times in text:<br>" 
        }
        draftHtml += "<ul>";
        for (var i=0; i<suggestedEventTimes.length; i++){
            draftHtml += "<li>";
            draftHtml += convert_event_to_suggestion_string(suggestedEventTimes[i], primaryTimeZoneOffset, primaryTimeZoneName, secondaryTimeZoneOffset, secondaryTimeZoneName);
            draftHtml += "</li>";
        }
        draftHtml += "</ul>";
    }

    if(!options.sendCalendar) {
        draftHtml += "<br><font color='#999999' size='1'>Powered by <a href='http://www.boomerangcalendar.com'><font color='#3d85c6'>Boomerang Calendar</font></a></font>";
    }


    if (location && locationType == "place"){
        add_location_to_local_storage (locationText, "place", locationText, location);
    }

    return draftHtml +"</div>";
}

function convert_event_to_suggestion_string(event, primaryTimeZoneOffset, primaryTimeZoneName, secondaryTimeZoneOffset, secondaryTimeZoneName){
    var output = "";
    var start = Date.parse(event.start);
    var end = Date.parse(event.end);
    var preferences = get_preferences();
    var dateFormat = preferences["customDateFormat"];
    var timeFormat = preferences["customTimeFormat"];
    var includeTimeZone = preferences["includeTimeZone"];

    var currentOffset = new Date().getTimezoneOffset();
    var primaryTimeZoneAdjustment = currentOffset - primaryTimeZoneOffset;
    var primaryStart = start.clone().addMinutes(primaryTimeZoneAdjustment);
    var primaryEnd = end.clone().addMinutes(primaryTimeZoneAdjustment);

    var anytime = event["allDay"];
    if (anytime){
        output = start.toString(dateFormat) + ", anytime";
    }
    else{
        if (isFinite(secondaryTimeZoneOffset) && secondaryTimeZoneName !== "???"){
            output = start.toString(dateFormat) + ", " + primaryStart.toString(timeFormat) + " - " + primaryEnd.toString(timeFormat) + " " + primaryTimeZoneName;
            var secondaryTimeZoneAdjustment = currentOffset - secondaryTimeZoneOffset;
            var secondaryStart = start.clone().addMinutes(secondaryTimeZoneAdjustment);
            var secondaryEnd = end.clone().addMinutes(secondaryTimeZoneAdjustment);
            output += " (" + secondaryStart.toString(timeFormat) + " - " + secondaryEnd.toString(timeFormat) + " " + secondaryTimeZoneName + ")";
        }
        else{
            output = start.toString(dateFormat) + ", " + primaryStart.toString(timeFormat) + " - " + primaryEnd.toString(timeFormat);
            if (includeTimeZone){
                output += " (" + primaryTimeZoneName + ")";
            }
        }
    }
    return output;
}

function convert_event_to_scheduling_string(event, primaryTimeZoneOffset, primaryTimeZoneName, secondaryTimeZoneOffset, secondaryTimeZoneName){
    var output = "";
    var start = Date.parse(event.start);
    var preferences = get_preferences();
    var timeFormat = preferences["customTimeFormat"];

    var currentOffset = new Date().getTimezoneOffset();
    var primaryTimeZoneAdjustment = currentOffset - primaryTimeZoneOffset;
    var primaryStart = start.clone().addMinutes(primaryTimeZoneAdjustment);

    var anytime = event["allDay"];
    if (anytime){
        output = "anytime";
    }
    else{
        output = primaryStart.toString(timeFormat);
    }
    output = output.replace(" ", "").replace(":00", "").toLowerCase();
    return output;
}

function add_insert_meeting_links() {
    var elems = by.ui_manips.add_insert_meeting_links();

    var add_insert_placeholder = function() {
        var $composeContainer = $(this).closest(".I5,.fN");
        // For pre-pop-in compose: ".Am.Al:not(:has(iframe))" for HTML compose, plain text is handled later
        // For new pop-in compose: ".LW-avf" for chrome and ".Am.Al > iframe" for firefox
        var $composeTextBody = $(".Am.Al:not(:has(iframe)), .LW-avf, .Am.Al > iframe", $composeContainer).last();
        $composeTextBody.addClass("b4c-insert-text-here");

        execute_javascript_on_document(function() {
            var textBody = by.get_frame().getElementsByClassName("b4c-insert-text-here")[0];
            by.selection.store(textBody.contentWindow || window);
        });

        $(this).data("compose-container", $composeContainer);
    };

    var availability_html_failure_callback = function(element_to_hide) {
        return function(error) {
            show_dialog(
                "The 'Share Availability' feature is having trouble loading."
              + "<br /> Please refresh your browser if you need the feature.");
            elems[element_to_hide].hide();
        };
    };

    var date_next_monday = function() {
        var SECONDS_IN_A_DAY = 60 * 60 * 24;
        var days_until_next_monday =
            new Date().getDay() == 0 ? 1 : (8 - new Date().getDay());
        var timestamp_next_monday = (new Date().getTime() / 1000)
          + SECONDS_IN_A_DAY * days_until_next_monday;
        return new Date(timestamp_next_monday * 1000)
    }

    var insert_into_composer = function(html_to_insert) {
        // dirty trick to pass arguments to remote javascript
        var $placeholder = $('#b4c_please_append_me_to_composer');
        if ($placeholder.length == 0) {
            $('body', get_frame()).append(
                "<div id='b4c_please_append_me_to_composer' style='display: none'></div>"
            );
            $placeholder = $('#b4c_please_append_me_to_composer');
        }
        $placeholder.html(html_to_insert);

        execute_javascript_on_document(function() {
            var textContainer = by.get_frame().getElementsByClassName("b4c-insert-text-here")[0];
            var range = by.selection.restore(textContainer.contentWindow || window);
            var bcalMeetingElt = by.get_frame().createElement("div");
            var bcalMeetingHtml = document.getElementById("b4c_please_append_me_to_composer").innerHTML
            bcalMeetingElt.innerHTML = bcalMeetingHtml;

            var editableElem = textContainer;
            if(textContainer.contentDocument) { editableElem = textContainer.contentDocument.body; }

            if(range && editableElem.contains(range.startContainer) && editableElem.contains(range.endContainer)) {
                range.deleteContents();
                range.insertNode(bcalMeetingElt);
                range.collapse(false);  // collapse to end of range, so calendar isn't highlighted
            } else {
                editableElem.insertBefore(bcalMeetingElt, editableElem.firstChild);
            }
        });
        $(".b4c-insert-text-here").removeClass("b4c-insert-text-here");
    };

    if (elems["next-few-days"].length > 0) {
        elems["next-few-days"]
            .mousedown(add_insert_placeholder)
            .click(function() {
                // generate html, insert it.
                window.by.availability_map.get_availability_html_async({
                    days_ahead: 5,
                    include_clickable_times: false,
                },  insert_into_composer, // success callback
                    availability_html_failure_callback('plan-group-meetings')
                );
            });
        elems["next-week"]
            .mousedown(add_insert_placeholder)
            .click(function() {
                // generate html, insert it.
                window.by.availability_map.get_availability_html_async({
                    days_ahead: 5, // options
                    start_date: date_next_monday(),
                    include_clickable_times: false,
                },  insert_into_composer, // success callback
                    availability_html_failure_callback('next-week')
                );
            });
    }
    elems["plan-group-meetings"].click(plan_group_link_clicked);
    // try to load hashid (as side-effect) before popping open the window.
    // think of this as a poor man's promise
    elems["plan-meetings"]
        .mousedown(add_insert_placeholder)
        .click(function() {
            var that = this;
            var open_suggest_times =
                function() {suggest_times_link_clicked($(that).data("compose-container"));};
            window.by.availability_map.ensure_hashid_loaded({
                success: open_suggest_times, error: open_suggest_times
            });
        });

    // include 'hey you should use bcal' suggestion
    by.discovery.discover_suggestmeeting(elems['plan-meetings']);
}


function plan_group_link_clicked(){
    var $composeContainer = $(this);

    var frameDoc = get_frame();
    var url = "https://boomerangcalendar.baydin.com/checklogin?guser=" + get_gmail_user();
    send_get_request_auth_wrapper(url, function(){
        var to = $("[name=to]", frameDoc).map(function() { return $(this).val(); }).toArray();
        var cc = $("[name=cc]", frameDoc).map(function() { return $(this).val(); }).toArray();

        var groupLoginUrl = "https://boomerangcalendar.baydin.com/group/schedule?recipients=" + encodeURIComponent(to.concat(cc).join(", "));
        create_popup(groupLoginUrl);
    });
}


function suggest_times_link_clicked(composeContainer){
    var $dialog = display_suggest_times_dialog(composeContainer);

    var b4c_calendar = $('#b4c-calendar-display', $dialog);
    update_local_event_cache(function(){
        rerender_b4c_calendar_after_cache_verification(b4c_calendar);
        verify_and_rerender_calendar_if_necessary(b4c_calendar);
    });
}

function show_dialog(message) {
    var frameDoc = get_frame();
    $(".bcal_dialogdiv").remove();

    var dialog = "<div class='bcal_dialogdiv' style='display:none;'>"+ message+"</div>";
    $("body", frameDoc).append($(dialog));

    $(".bcal_dialogdiv",frameDoc).dialog({
        title: 'Boomerang Calendar',
        position: ['center', 'top'],
        modal: true,
        resizable: true,
        buttons: [
            {
                text: "Close",
                "class": "b4c_close_dialog",
                click: function() { $(this).dialog("destroy"); }
            }
        ]
    });
}

function show_viral_dialog(message){
    var frameDoc = get_frame();
    $(".bcal_tweet_notification").remove();

    var dialog = "<div class='bcal_tweet_notification' style='display:none;'><div><span class='bcal_share_logo'><img src='" + get_bcal_big_logo_url() + "'/> </span> <span class='bcal_close_share'><img src='"+ get_bcal_close_icon_url() +
    "'/></span></div> <br/> <br/>" + message + "</div>";
    $("#gbx3", frameDoc).append($(dialog));
    $(".bcal_tweet_notification",frameDoc).css("display", "block");
    $(".bcal_tweet_notification",frameDoc).css("width", "60%");
    $(".bcal_tweet_notification",frameDoc).css("margin", "25px auto");
    $(".bcal_tweet_notification",frameDoc).css("z-index", "999");
    $(".bcal_tweet_notification",frameDoc).css("background-color", "lightyellow");
    $(".bcal_tweet_notification",frameDoc).css("padding", "10px 15px");
    $(".bcal_tweet_notification",frameDoc).css("font-size", "12px");
    $(".bcal_tweet_notification", frameDoc).css("-moz-box-shadow","0px 3px 6px #ccc");
    $(".bcal_tweet_notification", frameDoc).css("-webkit-box-shadow","0px 3px 6px #999");
    $(".bcal_tweet_notification", frameDoc).css("box-shadow", "0px 3px 6px #999");
    $('.bcal_close_share',frameDoc).click(close_viral_dialog);
}

function close_viral_dialog(){
    var frameDoc = get_frame();
    $(".bcal_tweet_notification", frameDoc).remove();
}
function show_sync_dialog() {
    var url = "https://boomerangcalendar.baydin.com/checklogin?guser=" + get_gmail_user();
    send_get_request_auth_wrapper(url, show_sync_dialog_helper);
    function show_sync_dialog_helper(data){
        var url = "https://boomerangcalendar.baydin.com/getsettings";
        send_get_request_auth_wrapper(url, show_sync_dialog_helper2);
    }
    function show_sync_dialog_helper2(data){
        var parsedData = $.parseJSON(data);

        var sampleStartDate = new Date(2012, 3, 25, 15, 0, 0);
        var sampleEndDate = new Date(2012, 3, 25, 16, 30, 0);
        var preferences = parsedData["preferences"];
        var customDateFormat = preferences["customDateFormat"];
        var customTimeFormat = preferences["customTimeFormat"];
        var includeTimeZone = preferences["includeTimeZone"];
        var defaultMeetingTime = preferences["defaultMeetingTime"];
        var startOfWeek = preferences["startOfWeek"];

        var $dialog = $(by.template.allSettings);
        $dialog.dialog({
            title: 'Boomerang Calendar',
            width: 700,
            height: ($(window).height() > 700 ? "auto": $(window).height()),
            modal: true,
            resizable: true,
            position: ['center','top'],
            open: function() { track_event("custom_format_dialog", "open"); },
            close: function() { rebuild_local_event_cache($.noop());},
            buttons: { "Ok": function() { $(this).dialog("close"); }}
        })
        .find(".customDateFormat")
            .val(customDateFormat)
        .end()
        .find(".customTimeFormat")
            .val(customTimeFormat)
        .end()
        .find(".customTimeZone")
            .attr("checked", includeTimeZone)
        .end()
        .find("select.customDateFormat>option")
            .each(function(){
                var $this =$(this);
                var format = $this.attr("dropdownTextFormat");
                $this.text(sampleStartDate.toString(format));
            })
        .end()
        .find("option#customTime1")
            .each(function(){
                var $this =$(this);
                var format = $this.attr("dropdownTextFormat");
                $this.text("12 hr format (e.g. " + sampleStartDate.toString(format) + " - " + sampleEndDate.toString(format) + ")");
            })
        .end()
        .find("option#customTime2")
            .each(function(){
                var $this =$(this);
                var format = $this.attr("dropdownTextFormat");
                $this.text("24 hr format (e.g. " + sampleStartDate.toString(format) + " - " + sampleEndDate.toString(format) + ")");
            })
        .end()
        .find(".updateSampleFormat")
            .change(function(){
                update_sample_date_format($dialog);
            })
        .end()
        .find(".dayOfWeek[value=" + startOfWeek + "]")
            .attr("checked", "checked")
        .end()
        .find(".defaultMeetingTime[value=" + defaultMeetingTime + "]")
            .attr("checked", "checked")
        .end()
        .find(".pref")
            .change(function(){
                onPrefChange($dialog);
            })
        .end();

        update_sample_date_format($dialog);

        var syncCalendars = parsedData["calendars"];
        for (var i=0; i < syncCalendars.length; i++){
            var calendar = syncCalendars[i];
            var $syncSetting = $(by.template.calendar_sync_option);
            $syncSetting.find(".bcalSummary").text(calendar["summary"]);
            $syncSetting.find(".calendar_sync").attr("value", calendar["id"]);
            if (calendar.isSynced){
                $syncSetting.find(".calendar_sync").prop("checked", true);
            }
            $(".b4c_sync_list", $dialog).append($syncSetting);

            if (calendar.accessRole == "writer" || calendar.accessRole == "owner"){
                var $defaultSetting = $(by.template.calendar_default_to_add);
                if (calendar.isDefault){
                    $defaultSetting.prop("checked", true);
                }
                $defaultSetting.text(calendar["summary"]);
                $defaultSetting.attr("value", calendar["id"]);
                $(".b4c_def_list", $dialog).append($defaultSetting);
            }
        }

        $('#def_calendar', $dialog).change(function () {
            var url = "https://boomerangcalendar.baydin.com/setdefault?id=" + $(this).val();
            send_get_request_auth_wrapper(url, function(){});
        });
        
        $(".calendar_sync", $dialog).change(function () {
            var url = "https://boomerangcalendar.baydin.com/togglesync?id=" + $(this).val();
            send_get_request_auth_wrapper(url, function(){});
        });

        function update_sample_date_format($dialog){
            var selectedDateFormat = $(".customDateFormat", $dialog).val();
            var selectedTimeFormat = $(".customTimeFormat", $dialog).val();
            var shouldIncludetimeZone = $(".customTimeZone", $dialog).is(":checked");
            var customStartFormat = selectedDateFormat + " " + selectedTimeFormat;
            var customEndFormat = selectedTimeFormat;
            var output = sampleStartDate.toString(customStartFormat);
            output += " - " + sampleEndDate.toString(customEndFormat);
            if (shouldIncludetimeZone){
                output += " (EST)";
            }
            $("#sampleText", $dialog).text(output);
        }
        function onPrefChange($dialog){
            var startOfWeek = $(".dayOfWeek:checked", $dialog).attr("value");
            var defaultMeetingTime = $(".defaultMeetingTime:checked", $dialog).attr("value");
            var customDateFormat = $(".customDateFormat", $dialog).val();
            var customTimeFormat = $(".customTimeFormat", $dialog).val();
            var includeTimeZone = $(".customTimeZone", $dialog).is(":checked") ? "True" : "False";
            var url = "https://boomerangcalendar.baydin.com/changepreferences?guser=" + get_gmail_user() + "&startOfWeek=" + startOfWeek + "&defaultMeetingTime=" + defaultMeetingTime +
                        "&customDateFormat=" + customDateFormat + "&customTimeFormat=" + customTimeFormat + "&includeTimeZone=" + includeTimeZone;
            send_get_request_auth_wrapper(url, function(){
                sync_preferences();
            });
        }
    }
}


function show_read_only_calendar_dialog() {
    var frameDoc = get_frame();
    $(".bcal_dialogdiv").remove();
    var message = "<div class='bcalReadOnlyWidget'><div class='eventDetailsContainer' style='display:none;'></div><div id='b4c-read-only-display'></div></div>";
    var dialog = "<div class='bcal_dialogdiv' style='display:none;'>"+ message+"</div>";
    $("body", frameDoc).append($(dialog));

    var browser_height = $(window).height();
    var dialog_height = 700;
    if (browser_height < 700) {
        dialog_height = browser_height;
    }
    $(".bcal_dialogdiv",frameDoc).dialog({
        title: 'Boomerang Calendar',
        width: 1050,
        height: dialog_height,
        modal: true,
        resizable: true,
        position: ['center','top'],
        open: function() { track_event("read-calendar-dialog", "open"); },
        close: function() { track_event("read-calendar-dialog", "close"); },
        buttons: { "Ok": function() { $(this).dialog("close"); }}
    });

    var preferences = get_preferences();
    var readOnlyCalendar = $('#b4c-read-only-display');
    readOnlyCalendar.fullCalendar({
        disableDragging: true,
        events: get_all_events_from_local_storage(),
        firstHour: 8,
        firstDay: preferences["startOfWeek"],
        allDaySlot: true,
        header: {
            left: '',
            center: 'prev, title, next',
            right:    'today agendaDay,agendaWeek,month'
        },
        buttonText: {
            prev: '&lt;',
            next: '&gt;'
        },
        contentHeight: 500,
        defaultView: 'agendaWeek',
        defaultEventMinutes: 60, //should parameterize this

        titleFormat: {
            month: 'MMMM yyyy',
            week: FULL_CALENDAR_TITLE_WEEK_FORMAT,
            day: FULL_CALENDAR_TITLE_DAY_FORMAT
        },
        columnFormat: {
            week: FULL_CALENDAR_COLUMN_WEEK_FORMAT
        },
        viewDisplay: function(view) {
            full_calendar_sync_and_render_current_view(view, readOnlyCalendar);
        }
    });

    update_local_event_cache(function(){
        rerender_b4c_calendar_after_cache_verification(readOnlyCalendar);
        verify_and_rerender_calendar_if_necessary(readOnlyCalendar);
    });
}

function insert_tentative_events($calendar, eventTitle, callback){
    var url = construct_tentative_event_url($calendar, eventTitle);
    $(".b4c-insert-content").replaceWith("Loading...");
    send_get_request_auth_wrapper(url, function insert_tentative_event_callback(data) {
        if (data.toLowerCase().indexOf("error") >= 0){ return show_dialog(data); }

        if (callback){
            callback(data);
        }

        display_gmail_notification('You added "' + eventTitle + '" to your calendar as tentative events.');
        update_local_event_cache($.noop);
    });
}

function construct_tentative_event_url($calendar, eventTitle){
    var timeSlots = construct_tentative_time_slots($calendar);
    var tentativeLocation = $("#b4c_place_autocomplete").val();
    if (tentativeLocation === "location"){
        tentativeLocation = "";
    }
    var url = "https://boomerangcalendar.baydin.com/inserttentativeevents?guser=" + get_gmail_user();
    url += "&title=" + encodeURIComponent(eventTitle);
    url += "&location=" + encodeURIComponent(tentativeLocation);
    url += "&timeSlots=" + JSON.stringify(timeSlots);
    return url;
}

function construct_tentative_time_slots($calendar){
    var tentativeEvents = get_suggested_events_from_calendar($calendar);
    var tentativeSlots = [];
    for (var i=0; i<tentativeEvents.length; i++){
        var tentativeEvent = tentativeEvents[i];
        var start = Date.parse(tentativeEvent.start);
        var end = Date.parse(tentativeEvent.end);
        tentativeSlots.push({"start": start.valueOf(), "end": end.valueOf()});
    }
    return tentativeSlots;
}

function send_suggest_times_request(){
    var isTentative = $("#b4c_mark_tentative_cb").attr("checked");
    if (isTentative){
        isTentative = "True";
    }
    else{
        isTentative = "False";
    }
    var url = "https://boomerangcalendar.baydin.com/suggesttimes?guser=" + get_gmail_user();
    url += "&numSuggestions=" + encodeURIComponent($('.proposedTime').length);
    url += "&isTentative=" + encodeURIComponent(isTentative);
    send_get_request_auth_wrapper(url, function callback_to_suggest_times_request(data){
        if (data === SUGGEST_TIME_COUNT_FOR_VIRAL_HOOK){
            var message = "<p class='bcal_share_header'>Did you know <strong>you just proposed your " + data +"th meeting </strong> with Boomerang Calendar?</p><p>Know people who arrange a lot of meetings like you? We'd really appreciate it if you share it with them.</p>";
            message += "<div class='bcal_share'><a href='" + generate_tweet_link(SUGGEST_TIME_VIRAL_HOOK_TEXT) + "' class='bcal_share_button'><img src='" + get_bcal_twitter_icon_url() + "' alt='Share on Twitter'/></a>";
            message +="<a href='https://www.facebook.com/dialog/feed?app_id=385824578155763&link=https://boomerangcalendar.com&picture=https://boomerangcalendar.com/img/successful_meetings.jpg&name=Boomerang%20Calendar&caption=Awesome%20plugin%20for%20people%20who%20arrange%20a%20lot%20%20of%20meetings&description="+encodeURIComponent(SUGGEST_TIME_VIRAL_HOOK_TEXT) + "&redirect_uri=https://boomerangcalendar.com' class='bcal_share_button'><img src='" + get_bcal_facebook_icon_url() + "' alt='Share on Facebook'/></a>";
            message += "<a href='https://plus.google.com/share?url=http%3A%2F%2Fboomerangcalendar.com'onclick='javascript:window.open(this.href, '', 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=600,width=600');return false;'' class='bcal_share_button'><img src='" + get_bcal_gplus_icon_url() + "' alt='Share on Google Plus'/></a></div>" ;

            setTimeout(function() { show_viral_dialog(message); }, 5000);
        }
    });
}

function display_custom_date_time_format_dialog(optional_continue_callback){
    var sampleStartDate = new Date(2012, 3, 25, 15, 0, 0);
    var sampleEndDate = new Date(2012, 3, 25, 16, 30, 0);
    var preferences = get_preferences();
    var customDateFormat = preferences["customDateFormat"];
    var customTimeFormat = preferences["customTimeFormat"];
    var includeTimeZone = preferences["includeTimeZone"];

    var $dialog = $(by.template.customDateTimeSettings);
    $dialog.dialog({
        title: 'Boomerang Calendar',
        width: 700,
        height: ($(window).height() > 700 ? "auto": $(window).height()),
        modal: true,
        resizable: true,
        position: ['center','top'],
        open: function() { track_event("custom_format_dialog", "open"); },
        close: function() { track_event("custom_format_dialog", "close"); }
    })
    .find(".customDateFormat")
        .val(customDateFormat)
    .end()
    .find(".customTimeFormat")
        .val(customTimeFormat)
    .end()
    .find(".customTimeZone")
        .attr("checked", includeTimeZone)
    .end()
    .find("select.customDateFormat>option")
        .each(function(){
            var $this =$(this);
            var format = $this.attr("dropdownTextFormat");
            $this.text(sampleStartDate.toString(format));
        })
    .end()
    .find("option#customTime1")
        .each(function(){
            var $this =$(this);
            var format = $this.attr("dropdownTextFormat");
            $this.text("12 hr format (e.g. " + sampleStartDate.toString(format) + " - " + sampleEndDate.toString(format) + ")");
        })
    .end()
    .find("option#customTime2")
        .each(function(){
            var $this =$(this);
            var format = $this.attr("dropdownTextFormat");
            $this.text("24 hr format (e.g. " + sampleStartDate.toString(format) + " - " + sampleEndDate.toString(format) + ")");
        })
    .end()
    .find("button#customFormatContinue")
        .click(function(){
            var url = construct_url_for_changing_preferences($dialog) ;
            send_get_request_auth_wrapper(url, function(){
                sync_preferences(what_to_do_after_closing_preferences_window);
            });
            function what_to_do_after_closing_preferences_window(){
                $dialog.dialog("close");
                if (optional_continue_callback){
                    optional_continue_callback();
                }
            }
        })
    .end()
    .find(".updateSampleFormat")
        .change(function(){
            update_sample_date_format($dialog);
        })
    .end();

    update_sample_date_format($dialog);

    function update_sample_date_format($dialog){
        var selectedDateFormat = $(".customDateFormat", $dialog).val();
        var selectedTimeFormat = $(".customTimeFormat", $dialog).val();
        var shouldIncludetimeZone = $(".customTimeZone", $dialog).is(":checked");
        var customStartFormat = selectedDateFormat + " " + selectedTimeFormat;
        var customEndFormat = selectedTimeFormat;
        var output = sampleStartDate.toString(customStartFormat);
        output += " - " + sampleEndDate.toString(customEndFormat);
        if (shouldIncludetimeZone){
            output += " (EST)";
        }
        $("#sampleText", $dialog).text(output);
    }

    function construct_url_for_changing_preferences($dialog){
        var customDateFormat = $(".customDateFormat", $dialog).val();
        var customTimeFormat = $(".customTimeFormat", $dialog).val();
        var includeTimeZone = $(".customTimeZone", $dialog).is(":checked");
        var includeTimeZoneString = includeTimeZone ? "True" : "False";

        var newPreferences = get_preferences();
        newPreferences["customDateFormat"] = customDateFormat;
        newPreferences["customTimeFormat"] = customTimeFormat;
        newPreferences["includeTimeZone"] = includeTimeZone;
        write_to_localStorage(LOCAL_STORAGE_PREFERENCES, newPreferences);

        var url = "https://boomerangcalendar.baydin.com/changepreferences?guser=" + get_gmail_user() +
            "&customDateFormat=" + customDateFormat + "&customTimeFormat=" + customTimeFormat + "&includeTimeZone=" + includeTimeZone;
        return url;
    }
}
