window.by = window.by || {};

// everything to do with showing the users features
// that they might now know about (kind of like ftui but half-way through)

(function($, exports) {
    /**
     * Add 'scheduling a meeting?' popup.
     */
    exports.discover_suggestmeeting = function($plan_meeting) {
        var composer = $plan_meeting.closest(".I5,.fN");
        if (composer.length == 0) {
            return; // false positive
        }

        if (!should_user_see_discovery('suggest-meeting')) {
            return;
        }

        by.ui_manips.observe_composer_text(function(new_text) {
            var keyword_found = is_about_scheduling(new_text);
            if (!keyword_found) {
                return;
            } else {
                record_user_saw_discovery('suggest-meeting');
                track_event('suggest-time-dialog', 'discovery-tooltip', keyword_found);
            }

            var tooltip_div = $(
                "<div role=tooltip' class='b4c-suggested-times-discovery-tooltip'>"
                +"  <div class='b4c-suggested-times-discovery-tooltip-text'>Scheduling a Meeting?</div>"
                +"  <div class='b4c-suggested-times-discovery-tooltip-tip'></div>"
                +"</div>")

            // tooltip's horizontal position should be based on
            // plann meeting button's horizontal position
            tooltip_div.css('left', $plan_meeting.position().left - 53);

            var tooltip_parent = $plan_meeting.children(':first');
            tooltip_parent.append(tooltip_div);

            // actually show everything
            tooltip_div.animate({'opacity':1}, 300);
            tooltip_parent.children(':first')
                .css('outline', '-webkit-focus-ring-color auto 5px');

            var hide_discovery_tooltip = function(fade_ms) {
                var fade_ms = fade_ms || 300;
                tooltip_div.animate({'opacity': 0}, fade_ms);
                tooltip_parent.children(':first').css('outline', 'none');
            };
            setTimeout(function() {hide_discovery_tooltip();}, 2500);

            // also hide if real thing moused over
            $plan_meeting.mouseover(function() {
                hide_discovery_tooltip(130);
            });

            $plan_meeting.click(function() {
                record_user_used_discovery('suggest-meeting');
            });

            return "done"; // tells mutator to stop listening
        }, composer);

    }

    var is_about_scheduling = function(text) {
        var keywords = ['schedul', 'meet', 'call', 'coffee',
            'lunch', 'dinner', 'drink', 'phone', 'skype'];
        var text_lower = text.toLowerCase();
        for (var x = 0; x < keywords.length; x++) {
            var keyword = keywords[x];
            if (text_lower.indexOf(keyword) > -1) {
                return keyword
            }
        }

        return false;
    }

    // TODO - should these all be in a common class?
    var should_user_see_discovery = function(feature_name) {
        var times_used = localStorage_getint(
            "discovery-used-" + feature_name);
        if (times_used > 1) {
            // user already uses feature, no need
            return false;
        }

        var times_seen = localStorage_getint("discovery-saw-" + feature_name);
        if (times_seen > 9 ) {
            // we've shown it to them quite a bit already
            return false;
        }

        // odds of showing go down over time
        return Math.random() < (1 / (times_seen + 1));
    };

    var record_user_saw_discovery = function(feature_name) {
        localStorage_increment("discovery-saw-" + feature_name);
    };

    var record_user_used_discovery = function(feature_name) {
        localStorage_increment("discovery-used-" + feature_name);
    };

    var localStorage_increment = function(key) {
        var item = localStorage.getItem(key);
        var item_num = parseInt(item || 0);
        localStorage.setItem(key, item_num + 1);
    };

    var localStorage_getint = function(key) {
        // TODO: use local_event_cache.write_to_localStorage
        // to take advantage of existing wrappers/space restraints
        var item = localStorage.getItem(key);
        return parseInt(item || 0);
    };

    // TODO: do we need to pass window.by as discovery?
})(jQuery, window.by.discovery || (window.by.discovery = {}));
