/** GMAIL SELECTORS **/
var EDIT_WINDOW_SELECTOR = ".dK,.aoX"; // .dk is pre-pop-in compose, .aoX is post-pop-in compose
var SUBJECT_LINE_SELECTOR = ".hP,.ez.nr,.aoT"; // .hP is pre-pop-in compose, .aoT is post-pop-in compose
var USER_NAME = "#gbmpn";
var DISPLAY_IMAGES_BELOW_SELECTOR = ".G8gNXb,.dNDeCd";
var LAST_ROW_OF_SEND_FORM_SELECTOR = ".ee";
var EMAIL_REGEX = /[a-zA-Z0-9\._\-]+@[a-zA-Z0-9\.\-]+\.[a-z\.A-Z]+/g;

var MESSAGE_BODY = ".ii";
var MENU_BAR_BUTTONS_SELECTOR = ".iH > div [role=button]";
var MENU_BAR_SELECTOR = ".iH > div";

var GMAIL_TOOLTIP = ".T-ays-W095bf";
var GMAIL_ADD_TO_CALENDAR_HOVER_1_SELECTOR = ".aBn";
var GMAIL_ADD_TO_CALENDAR_HOVER_2_SELECTOR = ".aQJ";
var GMAIL_ADD_TO_CALENDAR_HOVER_1_CLASS = "aBn";
var GMAIL_ADD_TO_CALENDAR_HOVER_2_CLASS = "aQJ";

function delete_gmail_add_to_calendar_ui(messageBody){
	var calendarHover1 = $(GMAIL_ADD_TO_CALENDAR_HOVER_1_SELECTOR, messageBody);
	var calendarHover2 = $(GMAIL_ADD_TO_CALENDAR_HOVER_2_SELECTOR, messageBody);

	calendarHover1.removeAttr("data-term");
	calendarHover1.removeAttr("tabindex");
	calendarHover1.removeClass(GMAIL_ADD_TO_CALENDAR_HOVER_1_CLASS);
	calendarHover2.removeClass(GMAIL_ADD_TO_CALENDAR_HOVER_2_CLASS);
}

function delete_gmail_add_to_calendar_tooltip(){
	$(GMAIL_TOOLTIP + ":contains('Add to Calendar')").parent().remove();
}

/* global classes */
var EMAIL_ALREADY_SCANNED_CLASS = "boomerang-meeting-email";
var EMAIL_NEVER_HIGHLIGHT_CLASS = "boomerang-meeting-do-not-highlight";

function get_thread_id()
{
	var loc = String(document.location);
	var threadId = loc.substr(loc.lastIndexOf("/") + 1);
	return threadId;
}

function get_frame()
{
	var oIframe = document.getElementById('canvas_frame');
	if (!oIframe){
		return document;
	}
	var frameDoc = (oIframe.contentWindow || oIframe.contentDocument);
	if (frameDoc.document) { frameDoc = frameDoc.document; }
	return frameDoc;
}

function get_thread_subject(composeContainer)
{
	var frameDoc = get_frame();

	// This is for the pop-in compse window
	var subject = $(SUBJECT_LINE_SELECTOR, composeContainer).filter(":visible").val();
	if(subject) { return subject; }

	// This is for pre-pop-in compose
	var subject = $(SUBJECT_LINE_SELECTOR, frameDoc).filter(":visible").val();
	if(subject) { return subject; }

	return $(SUBJECT_LINE_SELECTOR, frameDoc).filter(":visible").text() || "(no subject)";
}

function add_script_to_document(inputscript){
    var script = document.createElement('script');
    script.setAttribute("type", "application/javascript");
    script.textContent = inputscript.toString();
    document.body.appendChild(script); // run the script
}


function execute_javascript_on_document(fn) {
    var script = document.createElement('script');
    script.setAttribute("type", "application/javascript");
    script.textContent = '(' + fn + ')();';
    document.body.appendChild(script); // run the script
    document.body.removeChild(script); // clean up
}

// resize delay function.
// ensures that resize callback is only called 500ms after last resize
// http://stackoverflow.com/questions/2854407/javascript-jquery-window-resize-how-to-fire-after-the-resize-is-completed
var delay = (function(){
	var timer = 0;
	return function(callback, ms){
		clearTimeout (timer);
		timer = setTimeout(callback, ms);
	};
})();

function b4g_is_preview_pane(){
	return b4g_is_horizontal_preview_pane() || b4g_is_vertical_preview_pane();
}

function b4g_is_horizontal_preview_pane(){
	var frameDoc = get_frame();
	return $(".aph", frameDoc).filter(":visible").length > 0;
}

function b4g_is_vertical_preview_pane(){
	var frameDoc = get_frame();
	return $(".apj", frameDoc).filter(":visible").length > 0;
}

function resize_search_box_if_necessary()
{
	var frameDoc = get_frame();
	var manageLink = $("#b4c_manage", frameDoc);
	var searchButton = $("#gbqfb", frameDoc);
	var searchBar = $(".gbqfqw", frameDoc);
	var totalWidth = $("#gbq", frameDoc).width();
	var leftBarWidth= $("#gbq1", frameDoc).width();
	var rightMenuWidth= $("#gbu", frameDoc).width();
	var searchBoxWidth = totalWidth - (leftBarWidth + rightMenuWidth + 200);
	var currentBoxWidth = $('fieldset#gbqff',frameDoc).width();
	if (manageLink.overlaps(searchButton) || manageLink.overlaps(searchBar))
	{
		var calculatedWidth = searchBoxWidth + "px";
		$('fieldset#gbqff',frameDoc).css("width", calculatedWidth);
		$('#gbqfbw',frameDoc).css("left", calculatedWidth);
	}
	else if( currentBoxWidth < searchBoxWidth)
	{
		if (searchBoxWidth > 512) {
			searchBoxWidth = 512;
		}
		var calculatedWidth = searchBoxWidth + "px";
		$('fieldset#gbqff',frameDoc).css("width", calculatedWidth);
		$('#gbqfbw',frameDoc).css("left", calculatedWidth);
	}
}

function apply_top_menu_css(destination){
	var frameDoc= get_frame();
	var topMenuItem = $("#gbi4t", frameDoc);
	if(topMenuItem.length === 0){
		topMenuItem = $("#gbi4m1", frameDoc);
	}
	if(topMenuItem.length === 0){
		topMenuItem = $("#gbgs4dn", frameDoc);
	}
	if(topMenuItem.length === 1 ){
		$(destination).copyCSS($(topMenuItem));
	}
}



function get_target(e) {
	//Get the target of the given event
	e = e || window.event;
	return e.target || e.srcElement;
}

function is_new_googlebar(){
	return $('button', get_frame()).filter(function() {
		return $(this).attr("aria-label") === "Google Search";
	}).length > 0;
}

function is_pop_out_window(){
	var loc = String(document.location);
	return (loc.indexOf("ui=2") > 0 || loc.indexOf("view=cm") > 0) && get_gmail_logo().length === 0;
}

function get_gmail_logo(){
	var frameDoc = get_frame();
	return $("[role=banner]", frameDoc);
}

function get_gmail_user()
{
	var emailRegEx = /[a-zA-Z0-9\._\-]+@[a-zA-Z0-9\.\-]+\.[a-z\.A-Z]+/;

	var address = "";
	var loadingWords = $(".msg").html();
	address = emailRegEx.exec(loadingWords);

	if (!address)
	{
		address = "";
		var titleWords = document.title.split(" ");

		for(var i in titleWords)
		{
			var extractedAddress = emailRegEx.exec(titleWords[i]);
			if (extractedAddress)
			{
				address = extractedAddress[0];
			}
		}
	}
	else
	{
		address = address[0];
	}
	return address;
}

function get_latest_email_sent_date_in_thread(){
	try{
		var frameDoc = get_frame();
		var threadEmail = $(".ii:visible", frameDoc).last().parent();
		var timestampText = $(".g3", threadEmail).attr("alt").replace(" at", "");
		var emailDate = Date.parse(timestampText);
		return emailDate;
	}
	catch(err){
		return null;
	}
}

function boomerang_css_exists_in_framedoc(){
	var frameDoc = get_frame();
	return $("#boomerang-calendar-css-framedoc", frameDoc).length > 0;
}

function css_exists_in_root_document(){
	var urls = get_root_document_css_urls();

	for(var i = 0; i < urls.length; i++) {
		if($("#boomerang-calendar-css" + i).length === 0) { return false; }
	}

	return true;
}

function add_css_to_iframe(){
	function insert_css(){
		var url = get_bcal_css_url();
		$('<link type="text/css" rel="stylesheet" media="screen"/>')
			.attr({ id: "boomerang-calendar-css-framedoc", href: url + "?" + Math.random() })
			.appendTo(get_frame().head)
		;
	}
	setTimeout(insert_css, 3000);
}

function add_css_to_root_document() {
	function insert_css(){
		var urls = get_root_document_css_urls();
		for(var i = 0; i < urls.length; i++) {
			if($("#boomerang-calendar-css" + i).length !== 0) { continue; }

			$('<link type="text/css" rel="stylesheet" media="screen"/>')
				.attr({ id: "boomerang-calendar-css" + i, href: urls[i] + "?" + Math.random() })
				.appendTo(document.head);
		}
	}
	setTimeout(insert_css, 3000);
}

function get_draft_html(){
	var frameDoc = get_frame();
	var b4gDraftIframe = $("iframe.Am.Al", frameDoc).contents();
	var b4gDraftHtml = $("body", b4gDraftIframe);
	return b4gDraftHtml;
}

function get_plain_text_area_draft(){
	var frameDoc = get_frame();
	var plainTextArea = $("textarea.Ak.aXjCH:visible", frameDoc);
	return plainTextArea;
}

function prepend_html_to_draft(html){
	var isNewReply = $(".aDh").length > 0;
	if (isNewReply){
		prepend_html_to_new_reply(html);
	}
	else{
		prepend_html_to_old_reply(html);
	}
}

function prepend_html_to_old_reply(html){
	var draftHtml = get_draft_html();
	draftHtml.prepend(html);
}

function prepend_html_to_new_reply(html){
	var frameDoc = get_frame();
	var currentReply = $(".Am.Al", frameDoc).first();
	currentReply.html(currentReply.html() + html);
}

function is_text_written_in_draft(){
	var just_the_text = get_draft_html().children().not('br').not('body').not('script');
	return ($(just_the_text).length !== 0);
}

function open_reply_window(){
	var frameDoc = get_frame();
	var replyButtons =$(".amn", frameDoc).last();
	if (replyButtons.length === 0){ // old gmail
		replyButtons = $("textarea.ir", frameDoc);
	}
	replyButtons[0].click();
}

/**
 * Simulates a click by creating a mousedown event followed by a mouseup event.
 */
function simulate_click(index)
{
	var frameDoc = get_frame();
	var thisButton = this;
	var evt = frameDoc.createEvent("MouseEvents");
	evt.initMouseEvent("mousedown", true, true, window,
			0, 0, 0, 0, 0, false, false, false, false, 0, null);
	thisButton.dispatchEvent(evt);
	evt = frameDoc.createEvent("MouseEvents");
	evt.initMouseEvent("mouseup", true, true, window,
			0, 0, 0, 0, 0, false, false, false, false, 0, null);
	thisButton.dispatchEvent(evt);
}


/**
 * Forces the GMail notification message to remain hidden.
 */
function hide_gmail_notification()
{
	var frameDoc = get_frame();
	$(".UD", frameDoc).first().css("visibility", "hidden");
	$(".UB", frameDoc).first().css("visibility", "hidden");
	$(".vh", frameDoc).first().not(".boomerang").css("visibility", "hidden");
}

/**
 * Forces the GMail notification message to display.
 */
function show_gmail_notification()
{
	var frameDoc = get_frame();
	$(".UD", frameDoc).first().css("visibility", "visible");
	$(".UB", frameDoc).first().css("visibility", "visible");
	$(".vh", frameDoc).not(".boomerang").first().css("visibility", "visible");
	$(".vh", frameDoc).not(".boomerang").first().css("z-index", "9999999");

}

function display_gmail_notification(message)
{
	var frameDoc = get_frame();
	$(".vh", frameDoc).not(".boomerang").first().html(message);
	show_gmail_notification();
	setTimeout(clear_message_style, 5000);
}


/**
 * Undoes all of the visibility changes made to the GMail notification message.
 */
function clear_message_style()
{
	var frameDoc = get_frame();
	$(".UD", frameDoc).first().attr("style", "");
	$(".UB", frameDoc).first().attr("style", "");
	$(".vh", frameDoc).first().not(".boomerang").attr("style", "");
}


function get_buttons_by_text(buttonText){
	var frameDoc = get_frame();
	return $("[role=button]", frameDoc).filter(function() { return $(this).text().trim() === buttonText; });
}


/* helper function
   copying css from a source element to a destination element */

$.fn.copyCSS = function(source){
    var dom = $(source).get(0);
    var style;
    var dest = {};
    if(window.getComputedStyle){
        var camelize = function(a,b){
            return b.toUpperCase();
        };
        style = window.getComputedStyle(dom, null);

        for(var i = 0, l = style.length; i < l; i++){
            var prop = style[i];
            var camel = prop.replace(/\-([a-z])/g, camelize);
            var val = style.getPropertyValue(prop);
			if(camel === "color"  || camel === "backgroundColor") {
				dest[camel] = val;
			}
        }
        return this.css(dest);
    }

    if(style = dom.currentStyle){
        for(var prop in style){
            dest[prop] = style[prop];
        }
        return this.css(dest);
	}
	if(style = dom.style){
      for(var prop in style){
        if(typeof style[prop] !== 'function'){
          dest[prop] = style[prop];
        }
      }
    }
    return this.css(dest);
};

/**
 * Reads all e-mail addresses from a string of text and returns them as a single-space-separated list
 * @param text The string to search
 * @return The list of e-mail addresses
 */
function strip_email_addresses(text)
{
	var emailRegEx = /[a-zA-Z0-9\._+\-]+@[a-zA-Z0-9\.\-]+\.[a-z\.A-Z]+/g;
	var matches = text.match(emailRegEx);
	var result = "";
	for(var i in matches)
	{
		result += matches[i];
		if(i < matches.length - 1) { result += " "; }
	}
	return result;
}

function get_user_highlighted_node(){
	var frameDoc = get_frame();
	var highlightedNode;
	try{
		highlightedNode =  $(frameDoc.getSelection().getRangeAt(0).commonAncestorContainer);
	}
	catch(err){}
	return highlightedNode;
}

function get_gmail_language(){
	var language = $("html", document).attr("lang");
	if(language === "en" || language == null){
		return "English-US";
	}
	else if(language === "en-GB"){
		return "English-UK";
	}
	else{
		return "Other";
	}
}


function generate_tweet_link (shareContent) {
	return "http://twitter.com/home?status=" + encodeURIComponent(shareContent);
}

function generate_share_html(shareContent){
	return "<a href='" + generate_tweet_link(shareContent) + "'><span class='bcal_tweet'>Tweet</span></a><a href='https://www.facebook.com/dialog/feed?app_id=385824578155763&link=https://boomerangcalendar.com&picture=https://boomerangcalendar.com/img/successful_meetings.jpg&name=Try%20out%20Boomerang%20Calendar&caption=Awesome%20plugin%20for%20Gmail&description=With%20Boomerang%20Calendar%2C%20I%20just%20added%20my%2070th%20meeting%20w%2Fo%20leaving%20my%20inbox.&redirect_uri=https://boomerangcalendar.com'>Facebook</a>";
}
