(function($) {
	function truncateText(event, element){
		var curEventHead = $('.fc-event-head',element);
		var curEventContent = $('.fc-event-content',element);
		var curEventBg = $('.fc-event-bg',element);
		var content = $(curEventContent).text();
		if(!content)
		{
			if (curEventContent[0]){
				while( ($(curEventBg).height() - $(curEventHead).height()) < $(curEventContent)[0].scrollHeight ){
					content = content.replace(/\s+\S*$/, "");
					curEventContent.text(content + " ...");
				}
			}
		}
		else {
			content = $('.fc-event-title',element).text();
			if(content.length > 20){
				content = content.substring(0,20) + '...';
			}
			$('.fc-event-title',element).text(content);
		}
	}

	function initTooltip() {
		return $(by.template.eventTooltip)
			.find(".by-icon-closethick").click(function(e) {
				e.preventDefault();
				$(this).closest(".b4c-event-details").hide();
			}).end()
			.mouseout(function(e) {
				if(this === e.relatedTarget) { return; }
				if($.contains(this, e.relatedTarget)) { return; }

				var elem = $(this).data("event-elem");
				if(elem === e.relatedTarget) { return; }
				if($.contains(elem, e.relatedTarget)) { return; }
				
				$(this).hide();
			})
			.hide()
		;
	}

	function showTooltip(event, elem) {
		var $elem = $(elem);

		var $calendar = $elem.closest(".fc");
		var $tooltip = $calendar.data("tooltip");

		if(!$tooltip) {
			$tooltip = initTooltip();

			$calendar
				.data("tooltip", $tooltip)
				.append($tooltip)
				.find(".fc-agenda-slots").offsetParent().parent()
					.scroll(function() { $tooltip.hide(); })
			;
		}

		var timespan = event.start.toString(B4C_DISPLAY_PROPOSE_DATE_FORMAT) + " – " + event.end.toString('h:mmtt');
		$tooltip
			.data("event-elem", elem)
			.show()
			.position({
				of: elem,
				my: "left top",
				at: "center",
				within: $calendar.parents(":ui-dialog")
			})
			.find(".b4c-event-title").text(event.title).end()
			.find(".b4c-event-timespan").text(timespan).end()
			.find(".b4c-event-calendar").text(event.calendarId)
		;

		var $eventDelete = $(".b4c-event-delete", $tooltip);
		$eventDelete.unbind("click");
		$eventDelete.click(function(){
			$calendar.fullCalendar("removeEvents", event.id);
			$calendar.trigger("refresh-proposed-times");
			$tooltip.hide();
		});

		if (event.className.indexOf("suggestedSlot") >= 0){
			$(".b4c-event-calendar", $tooltip).hide();
			$(".b4c-event-delete-block", $tooltip).show();
		}
		else{
			$(".b4c-event-calendar", $tooltip).show();
			$(".b4c-event-delete-block", $tooltip).hide();
		}
	}

	$.fn.fullCalendar.setDefaults({
		eventRender: function(event,element) {
			truncateText(event, element);
		},
		eventMouseover: function(calEvent) {
			if (calEvent.className.indexOf("suggestedSlot") == -1){
				showTooltip(calEvent, this);
			}
		},
		eventMouseout: function(calEvent, e) {
			if(this === e.relatedTarget) { return; }
			if($.contains(this, e.relatedTarget)) { return; }

			var $tooltip = $(this).closest(".fc").data("tooltip");
			if(!$tooltip || $tooltip.length <= 0) { return; }
			if($tooltip[0] === e.relatedTarget) { return; }
			if($.contains($tooltip[0], e.relatedTarget)) { return; }

			if($tooltip) { $tooltip.hide(); }
		},
		eventClick: function(calEvent) {
			showTooltip(calEvent, this);
		}
	});
})(jQuery);
