var pageMod = require("sdk/page-mod");
var self = require("sdk/self");
var windows = require("sdk/windows").browserWindows;
var tabs = require("sdk/tabs");
var data = require("sdk/self").data;
var Request = require("sdk/request").Request;
var timers = require("sdk/timers");
var ss = require("sdk/simple-storage");

var meetings_css = data.url("firefox_extension_site_media/css/meetings.css");
var jquery_ui_css = data.url("firefox_extension_site_media/css/jquery-ui.css");
var meetings_framedoc_css = data.url("firefox_extension_site_media/css/meetings-framedoc.css");
var calendar_colors_css = data.url("firefox_extension_site_media/css/calendar-colors.css");
var full_calendar_css = data.url("firefox_extension_site_media/css/fullcalendar.css");

var bcal_img = data.url("firefox_extension_site_media/img/bcal16.png");
var plus_img = data.url("firefox_extension_site_media/img/plus.jpg");
var show_cal_img = data.url("firefox_extension_site_media/img/show_cal.jpg");

var calendar_gif = data.url("firefox_extension_site_media/img/calendar.gif");
var ui_icons_png = data.url("firefox_extension_site_media/img/ui-icons.png");

var wc_accounts_screenshot_url = data.url("firefox_extension_site_media/img/google_accounts_screenshot.png");
var wc_suggest_times_screenshot_url = data.url("firefox_extension_site_media/img/wc_suggest_times.png");
var wc_highlight_email_screenshot_url = data.url("firefox_extension_site_media/img/wc_highlight_email.png");
var wc_bcal_menu_screenshot_url = data.url("firefox_extension_site_media/img/wc_bcal_menu.png");

var bcal_logo_png = data.url("firefox_extension_site_media/img/bcal-logo.png");
var bcal_fb_png = data.url("firefox_extension_site_media/img/bcal_fb_png");
var bcal_gplus_png = data.url("firefox_extension_site_media/img/bcal_gplus_png");
var bcal_twitter_png = data.url("firefox_extension_site_media/img/bcal_twitter.png");
var close_png = data.url("firefox_extension_site_media/img/close.png");
var powered_by_yelp_png = data.url("firefox_extension_site_media/img/Powered_By_Yelp_White.png");

var bcal_png = data.url("firefox_extension_site_media/img/bcal.png");
var group_png = data.url("firefox_extension_site_media/img/group.png");
var availability_nextfewdays_png = data.url("firefox_extension_site_media/img/insert2days-flat.png");
var availability_nextweek_png = data.url("firefox_extension_site_media/img/insertweek-flat.png");

var offset_to_conical_json = data.url("lib/timezones/offset-to-conical.json");
var timezone_info_json = data.url("lib/timezones/timezone-info.json");


if (!ss.storage.addresses){
	ss.storage.addresses = [];
}

pageMod.PageMod({
	include: ["https://mail.google.com/*", "http://mail.google.com/*"],
	contentScriptWhen: 'end',
	contentScriptFile: [
						data.url("bridge.js"),
						data.url("firefox_extension_specific.js"),
						data.url("lib/jquery.js"),
						data.url("lib/jquery-ui.js"),
						data.url("lib/meetings-jquery-extensions.js"),
						data.url("lib/fullcalendar/fullcalendar.js"),
						data.url("lib/fullcalendar/custom-defaults.js"),
						data.url("gmail_selectors.js"),
						data.url("lib/timezones/menus.js"),
						data.url("event-randomizer.js"),
						data.url("template.js"),
						data.url("gmail-ui-manipulations.js"),
						data.url("feature_discovery.js"),
						data.url("availability_map.js"),
						data.url("meeting_decider.js"),
						data.url("dates.js"),
						data.url("local_event_cache.js"),
						data.url("boomerang_meetings.js"),
						data.url("code-ran-outside-sandbox.js")
						],
	onAttach: function onAttach(worker) {
		worker.port.on("send_get_request", function(urlAndCallbackData) {
			var callbackId = urlAndCallbackData["callbackId"];
			var url = urlAndCallbackData["url"];
			var shouldBeSilent = urlAndCallbackData["shouldBeSilent"];
			var shouldAuthAndRetry = urlAndCallbackData["shouldAuthAndRetry"];

			var getRequest = Request({
				url: url,
				onComplete: function (response) {
					worker.port.emit("response_from_get_request",
						{"callbackId": callbackId, "responseStatus": response["status"],
						"responseText": response["text"], "shouldBeSilent": shouldBeSilent,
						"shouldAuthAndRetry": shouldAuthAndRetry, "url": url}
						);
				}
			});
			getRequest.get();
		});
		worker.port.on("get_static_img", function(data) {
			worker.port.emit("return_static_img", {"meetings_css": meetings_css, "jquery_ui_css": jquery_ui_css,
													"meetings_framedoc_css": meetings_framedoc_css,
													"calendar_colors_css" : calendar_colors_css,
													"full_calendar_css": full_calendar_css,
													"bcal_img": bcal_img,
													"plus_img": plus_img, "show_cal_img": show_cal_img,
													"calendar_gif": calendar_gif, "ui_icons_png": ui_icons_png,
													"wc_accounts_screenshot_url": wc_accounts_screenshot_url,
													"wc_suggest_times_screenshot_url": wc_suggest_times_screenshot_url,
													"wc_highlight_email_screenshot_url": wc_highlight_email_screenshot_url,
													"wc_bcal_menu_screenshot_url": wc_bcal_menu_screenshot_url,
													"bcal_logo_png" : bcal_logo_png,
													"bcal_fb_png" : bcal_fb_png,
													"bcal_gplus_png" : bcal_gplus_png,
													"bcal_twitter_png" : bcal_twitter_png,
													"powered_by_yelp_png" : powered_by_yelp_png,
													"close_png" : close_png,
													"offset_to_conical_json" : offset_to_conical_json,
													"timezone_info_json" : timezone_info_json,
													"bcal_png" : bcal_png,
													"group_png" : group_png,
													"availability_nextfewdays_png" : availability_nextfewdays_png,
													"availability_nextweek_png" : availability_nextweek_png
													})
		});
		worker.port.on("active_tab", function(callbackData) {
			var guser = callbackData["guser"];
			var callbackId = callbackData["callbackId"];

			var isActiveTab = guser!= null && guser.length > 0 && tabs.activeTab.title.toLowerCase().indexOf(guser.toLowerCase()) >= 0;
			if (isActiveTab){
				worker.port.emit("call_function", {"callbackId": callbackId,} );
			}
		});
		worker.port.on("auth_popup", function(urlAndCallbackData) {
			var url = urlAndCallbackData["authurl"];
			var callbackId = urlAndCallbackData["callbackId"];
			var shouldBeSilent = urlAndCallbackData["shouldBeSilent"];

			if (!shouldBeSilent){
				windows.open({
					url: url,
					onOpen: function(window) {
						timers.setTimeout(function(){
							var loginTitle = window.title;
							if (loginTitle != null && loginTitle.toLowerCase().indexOf("successful") >=0 ){
								window.close();
							}
						}, 20000)

					},

					onClose: function(window) {

						worker.port.emit("call_function",
							{"callbackId": callbackId,}
							);
					}
				});
			}
			else{
				tabs.open({
					url: url,
					inBackground: true,
					onOpen: function(tab) {
						timers.setTimeout(function(){
							var loginTitle = tab.title;
							if (loginTitle != null && loginTitle.toLowerCase().indexOf("successful") >=0 ){
								tab.close();
							}
							else{
								tab.activate();
							}
						}, 20000)
					},
				});
			}
		});
		worker.port.on("popup", function(urlAndCallbackData) {
			var url = urlAndCallbackData["url"];
			tabs.open({
				url: url
			});

		});
		worker.port.on("store_email_address", function(emailAddressData) {
			var email = emailAddressData["email"];
			if (ss.storage.addresses.indexOf(email) == -1){
				ss.storage.addresses.push(email);
			}
		});
		worker.port.on("get_email_addresses", function(callbackData) {
			worker.port.emit("receive_email_addresses", {"emails": ss.storage.addresses});
		});
	}
});

